
AppTitle "SpaceWars 4"
HidePointer

Const screenx=640
Const screeny=480
Const screenxmid=screenx/2
Const screenymid=screeny/2

Const DebugLoad = 0;1;False
Const DummyImages = 0;1;False

startmem=AvailVidMem()
Graphics screenx,screeny,0,3
Global FontLarge = LoadFont( "Tahoma" , 26 )
Global FontMedium = LoadFont( "Tahoma" , 17 , True )
Global FontSmall = LoadFont( "Small Fonts" , 12 )
ScreenMessage "LOADING"
api_ShowWindow api_GetActiveWindow() , 3  ; maximize window
Color 224*0.7,240*0.7,256*0.7
SetFont FontSmall

;----------------------------------------------------
AutoMidHandle True		;'game' gfx
ship_wb=LoadAnimImageP("GFX\Game\Ships\SideA\wbroll.bmp",36,36,0,440)
ship_jv=LoadAnimImageP("GFX\Game\Ships\SideA\jvroll.bmp",36,36,0,440)
ship_lv=LoadAnimImageP("GFX\Game\Ships\SideA\lvroll.bmp",36,36,0,440)
junk_wb=LoadAnimImageP("GFX\Game\Ships\SideA\junkwb.bmp",16,16,0,90)
junk_jv=LoadAnimImageP("GFX\Game\Ships\SideA\junkjv.bmp",16,16,0,90)
junk_lv=LoadAnimImageP("GFX\Game\Ships\SideA\junklv.bmp",16,16,0,90)
mothership=LoadAnimImageP("GFX\Game\Ships\SideA\mothership.png",256,256,0,40)
escort=LoadAnimImageP("GFX\Game\Ships\SideA\escort.png",169,169,0,40)
exhaust=LoadAnimImageP("GFX\Game\Fx\Exhaust.bmp",16,16,0,38)
bullet1=LoadAnimImageP("GFX\Game\Fx\Bullets.bmp",5,5,0,40)
bombs=LoadAnimImageP("GFX\Game\Fx\bombs.bmp",16,16,0,130)
trail=LoadAnimImageP("GFX\Game\Fx\trail.bmp",16,16,0,50)
bombflsh=LoadAnimImageP("GFX\Game\Fx\Bombflsh.bmp",8,8,0,6)
explode0=LoadAnimImageP("GFX\Game\Fx\X0.bmp",16,16,0,7)
explode0_s=LoadAnimImageP("GFX\Game\Fx\X0_S.bmp",16,16,0,7)
explode1=LoadAnimImageP("GFX\Game\Fx\X1.bmp",128,64,0,8)
explode2=LoadAnimImageP("GFX\Game\Fx\X2.bmp",80,80,0,44)
turret2=LoadAnimImageP("GFX\Game\Ships\turret2.bmp",16,16,0,40)
turret2a=LoadAnimImageP("GFX\Game\Ships\turret2a.bmp",16,16,0,40)
turretO=LoadAnimImageP("GFX\Game\Ships\turretO.bmp",400,400,0,40)

AutoMidHandle False		;UI gfx
icons=LoadAnimImageP("GFX\Game\Ui\Icons.bmp",26,24,0,54)
iconmask=LoadImageP("GFX\Game\Ui\mask.bmp")
icondoor=LoadAnimImageP("GFX\Game\Ui\Icondoor.bmp",11,13,0,24)
hlthbar=LoadAnimImageP("GFX\Game\Ui\hlthbar.bmp",116,28,0,2)
disp=LoadImageP("GFX\Game\Ui\disp.bmp")
engyfont=LoadAnimImageP("GFX\Game\Ui\engyfont.bmp",16,24,0,10)
ledfont=LoadAnimImageP("GFX\Game\Ui\led.bmp",7,10,0,10)

Dim font(4)
font(0)=LoadAnimImageP("GFX\Game\Ui\specfont.bmp",7,8,0,768,1)
font(1)=LoadAnimImageP("GFX\Game\Ui\shrtfont.bmp",8,8,0,768,1)
font(2)=LoadAnimImageP("GFX\Game\Ui\tallfont.bmp",8,12,0,768,1)
font(3)=LoadAnimImageP("GFX\Game\Ui\largefont.bmp",12,18,0,768,1)
font(4)=LoadAnimImageP("GFX\Game\Ui\hugefont.bmp",16,24,0,768,1)

Dim font_x(4) : Dim font_y(4)
font_x(0)=7   : font_y(0)=8
font_x(1)=8   : font_y(1)=8
font_x(2)=8   : font_y(2)=12
font_x(3)=12  : font_y(3)=18
font_x(4)=16  : font_y(4)=24

Const max_misc=14
Const max_star=7
Dim bg_misc(13)
For bg=1 To max_misc
	bg_misc(bg-1)=LoadImageP("GFX\Game\Bg\bg"+bg+".bmp")
Next
Dim bg_star(6)
For bg=1 To max_star
	bg_star(bg-1)=LoadImageP("GFX\Game\BG\star"+bg+".bmp")
Next

Function LoadImageP( filename$ , neverdummy=False )
    Local image
    If DummyImages = True And neverdummy = False
		image = CreateImageRect( 16,16 )
        If DebugLoad
            Print "(dummy) 16x16 "+filename
        End If
    Else
        image = LoadImage( filename )
        If DebugLoad
            Print ImageWidth(image)+"x"+ImageHeight(image)+"x1 "+filename
        End If
    End If
    Return image
End Function

Function LoadAnimImageP( filename$ , width,height , offset,frames , neverdummy=False )
    Local image
    If DummyImages = True And neverdummy = False
        ;image = CreateImageRect( width,height , frames )
        image = CreateImageRect( 16,16 , frames )
        If DebugLoad
            ;Print "(dummy) "+width+"x"+height+"x"+frames+" "+filename
            Print "(dummy) 16x16x"+frames+" "+filename
        End If
    Else
        image = LoadAnimImage( filename , width,height , offset,frames )
        If DebugLoad
            Print ImageWidth(image)+"x"+ImageHeight(image)+"x"+frames+" "+filename
        End If
    End If
    Return image
End Function

; create an image as placeholder graphics (rect)
Function CreateImageRect( w,h , f=1 )
	Local image = CreateImage( w,h , f )
	Local n
	Local r,g,b
	r = ColorRed()
	g = ColorGreen()
	b = ColorBlue()
	Color 255,255,255
	For n = 1 To f
		SetBuffer ImageBuffer( image , n-1 )
		Rect 0,0 , w,h , False
	Next
	SetBuffer BackBuffer()
	Color r,g,b
	Return image
End Function

;----------------------------------------------------
.INIT_MUSIC
;0=off / -1=on
Const musicon=-1

Include "inc\bass.bb"
Include "inc\bass_midi.bb"
If DebugLoad Then Print "Loading music"
Local HWND = SystemProperty( "AppHWND" )  ;BASS_HWND() 
If Not BASS_Init(musicon,44100,0,HWND,0) Then DebugLog "Bass init error!"

Type BASS_MIDI_FONT
	Field font,preset,bank
End Type
sfont.BASS_MIDI_FONT=New BASS_MIDI_FONT
sfont\font=BASS_MIDI_FontInit("SND\music\FluidR3_GM.sf2",0)
If sfont\font=0 Then DebugLog("error loading soundfont.")
sfont\preset=-1
sfont\bank=0
If BASS_MIDI_StreamSetFonts(0,sfont,1)=0 Then DebugLog("error initializing soundfont.")

;read music playlists
Const battlemusdir$="snd\music\battle\"

dir=ReadDir(battlemusdir)
Repeat
	file$=NextFile$(dir)
	If FileType(battlemusdir+file$)=2 And file$<>"." And file$<>".." Then	;parse subdirs in battle music folder
		max_list=max_list+1													;update max_list var (=# of subdirs)
		dir2=ReadDir(battlemusdir+file$)
		Repeat
			file2$=NextFile$(dir2)
			If Lower$(Right$(file2$,4))=".mid" Then max_music=max_music+1	;update max_music, total tracks var
		Until file2$=""
		CloseDir(dir2)
	EndIf
Until file$=""
CloseDir(dir)
max_music=max_music-1
max_list=max_list-1

;init arrays based on totals calculated in previous loop
Dim playlist$(max_list)	;names of different folders, ie 'playlists'
Dim track$(max_music)	;filename of all tracks in all folders to be used by BASS commands
Dim index(max_music)	;index number for correct playlist folder for each track
dir=ReadDir(battlemusdir)
Repeat
	file$=NextFile$(dir)
	If FileType(battlemusdir+file$)=2 And file$<>"." And file$<>".." Then	;parse files again, this time filling the arrays
		playlist$(countpl)=file$+"\"
		dir2=ReadDir(battlemusdir+file$)
		Repeat
			file2$=NextFile$(dir2)
			If Lower$(Right$(file2$,4))=".mid" Then
				track$(countrk)=file2$
				index(countrk)=countpl
				countrk=countrk+1
			EndIf
		Until file2$=""
		CloseDir(dir2)
		countpl=countpl+1
	EndIf
Until file$=""
CloseDir(dir)

;----------------------------------------------------
.define_constants
Const radarsize=screenx/8
Const radarrange=2000

Const mapxbar=screenx-150
;Const mapxmid=(screenx-mapxbar)/2
Const mapxmid=mapxbar/2

Const exhaustdelay=80			;fighter exhaust flame delay
Const particledelay=40			;bullet particle trail delay
Const traildelay=35				;bomb smoke trail delay
Const rechargedelay=100			;shield&afterburner recharge rate
Const reloaddelay=2500			;bomb reload rate when docked

Const state_seek=0
Const state_attack=1
Const state_regroup=2
Const state_goto=3
Const state_return=4
Const state_docked=5

Const maxroles=2
Const role_fighter=0
Const role_bomber=1
Const role_capship=2

Const maxcallsign=screenx/80
Const chatsize_y=screeny/60
Const chatsize_x=maxcallsign*8

Const msg_motivate=0
Const msg_detect=1
Const msg_detectattack=2
Const msg_detectre=3
Const msg_attack=4
Const msg_done=5
Const msg_die=6
Const msg_kill=7
Const msg_win=8
Const msg_return=9

Const font_gray=-32
Const font_green=64
Const font_blue=160
Const font_red=256
Const font_yellow=352
Const font_purple=448
Const font_orange=544
Const font_pink=640

Const maxfreqs=1
Const maxbarrels=3
Const maxformshp=3
Const maxturrets=9

Const maxthrust = 15

Include "inc\Math.lib.bb"

;----------------------------------------------------
Global currentcol#=0									;read various UI & system colors from colors.bmp
Dim colour(127,39,2)
colors=LoadImageP("GFX\Game\Ui\colors.bmp",1)
SetBuffer ImageBuffer(colors)
LockBuffer ImageBuffer(colors)
For x=0 To 127
	For y=0 To 39
		pixel=ReadPixelFast(x,y)
		colour(x,y,0)=(pixel Shr 16) And $ff	;red
		colour(x,y,1)=(pixel Shr 8) And $ff		;green
		colour(x,y,2)=pixel And $ff				;blue
	Next
Next
UnlockBuffer()
FreeImage colors
Function SetColorXY( x,y )
    Color colour(x,y,0),colour(x,y,1),colour(x,y,2)
End Function

;----------------------------------------------------
;ship & squad names
If DebugLoad Then Print "Loading information"

file=ReadFile("TXT\formations.txt")				;read formation names from formations.txt
maxforms=ReadLine(file)
Dim designation$(maxfreqs,maxforms)
For a=0 To maxfreqs
	For b=0 To maxforms
		designation(a,b)=ReadLine(file)
	Next
	ReadLine(file)
Next

file=ReadFile("TXT\shipnames.txt")				;read capital ship names from shipnames.txt
maxships=ReadLine(file)
Dim shipname$(maxfreqs,maxships)
For a=0 To maxfreqs
	For b=0 To maxships
		shipname(a,b)=ReadLine(file)
	Next
	ReadLine(file)
Next

;formation roles
file=ReadFile("TXT\roles.txt")					;read roles from roles.txt
Dim role$(maxroles,1)
For a=0 To maxroles
	For b=0 To 1
		role(a,b)=ReadLine(file)
	Next
Next

;ingame messages
file=ReadFile("TXT\Messages\spotted.txt")
Global maxspotted
Repeat
	ReadLine(file)
	maxspotted=maxspotted+1
Until Eof(file)
maxspotted=maxspotted-1
Dim chat_spotted$(maxspotted)
SeekFile(file,0)
For a=0 To maxspotted
	chat_spotted$(a)=ReadLine(file)
Next
CloseFile(file)

file=ReadFile("TXT\Messages\target2.txt")
Global maxtarget
Repeat
	ReadLine(file)
	maxtarget=maxtarget+1
Until Eof(file)
maxtarget=maxtarget-1
Dim chat_target$(maxtarget)
SeekFile(file,0)
For a=0 To maxtarget
	chat_target$(a)=ReadLine(file)
Next
CloseFile(file)

file=ReadFile("TXT\Messages\target1.txt")
Global maxtargetre
Repeat
	ReadLine(file)
	maxtargetre=maxtargetre+1
Until Eof(file)
maxtargetre=maxtargetre-1
Dim chat_targetre$(maxtargetre)
SeekFile(file,0)
For a=0 To maxtargetre
	chat_targetre$(a)=ReadLine(file)
Next
CloseFile(file)

file=ReadFile("TXT\Messages\motivate.txt")
Global maxmotivate
Repeat
	ReadLine(file)
	maxmotivate=maxmotivate+1
Until Eof(file)
maxmotivate=maxmotivate-1
Dim chat_motivate$(maxmotivate)
SeekFile(file,0)
For a=0 To maxmotivate
	chat_motivate$(a)=ReadLine(file)
Next
CloseFile(file)

file=ReadFile("TXT\Messages\done.txt")
Global maxdone
Repeat
	ReadLine(file)
	maxdone=maxdone+1
Until Eof(file)
maxdone=maxdone-1
Dim chat_done$(maxdone)
SeekFile(file,0)
For a=0 To maxdone
	chat_done$(a)=ReadLine(file)
Next
CloseFile(file)

file=ReadFile("TXT\Messages\confirm.txt")
Global maxconfirm
Repeat
	ReadLine(file)
	maxconfirm=maxconfirm+1
Until Eof(file)
maxconfirm=maxconfirm-1
Dim chat_confirm$(maxconfirm)
SeekFile(file,0)
For a=0 To maxconfirm
	chat_confirm$(a)=ReadLine(file)
Next
CloseFile(file)

file=ReadFile("TXT\Messages\die_fm.txt")
Global maxdie_fm
Repeat
	ReadLine(file)
	maxdie_fm=maxdie_fm+1
Until Eof(file)
maxdie_fm=maxdie_fm-1
Dim chat_diefm$(maxdie_fm)
SeekFile(file,0)
For a=0 To maxdie_fm
	chat_diefm$(a)=ReadLine(file)
Next
CloseFile(file)

file=ReadFile("TXT\Messages\die_cs.txt")
Global maxdie_cs
Repeat
	ReadLine(file)
	maxdie_cs=maxdie_cs+1
Until Eof(file)
maxdie_cs=maxdie_cs-1
Dim chat_diecs$(maxdie_cs)
SeekFile(file,0)
For a=0 To maxdie_cs
	chat_diecs$(a)=ReadLine(file)
Next
CloseFile(file)

file=ReadFile("TXT\Messages\kill.txt")
Global maxkill
Repeat
	ReadLine(file)
	maxkill=maxkill+1
Until Eof(file)
maxkill=maxkill-1
Dim chat_kill$(maxkill)
SeekFile(file,0)
For a=0 To maxkill
	chat_kill$(a)=ReadLine(file)
Next
CloseFile(file)

file=ReadFile("TXT\Messages\winner.txt")
Global maxwinner
Repeat
	ReadLine(file)
	maxwinner=maxwinner+1
Until Eof(file)
maxwinner=maxwinner-1
Dim chat_win$(maxwinner)
SeekFile(file,0)
For a=0 To maxwinner
	chat_win$(a)=ReadLine(file)
Next
CloseFile(file)

file=ReadFile("TXT\Messages\return.txt")
Global maxreturn
Repeat
	ReadLine(file)
	maxreturn=maxreturn+1
Until Eof(file)
maxreturn=maxreturn-1
Dim chat_return$(maxreturn)
SeekFile(file,0)
For a=0 To maxreturn
	chat_return$(a)=ReadLine(file)
Next
CloseFile(file)

;----------------------------------------------------
;game types
Type heuristics
	Field formations[maxroles],available[maxroles],targets[maxroles],assignment[maxroles]
	Field mother.ship
End Type
Type player
	Field ship.ship
	Field x#,y#,freq,sel_turret
	Field hlthbar_x#,hlthbar_y
	Field key_left,key_right,key_up,key_down,key_fireA,key_fireB,key_multi,key_afterburner
	Field wins,loss,screenshake
End Type
Type npc
	Field ship.ship
	Field interceptcheck,targetcheck,dist
End Type
Type ship
	Field ship.ship_stats,formation.formation,target.ship,docked.ship
	Field x#,y#,s#,t#,angle#,target_angle#,roll#,thrust#,exhaust_t,designation,docked_t
	Field hp,shield,recharge_t,ammo,reload_gun,barrel,multi,bombs,reload_bmb,freq,dead,formation_id,fuel#,reburn_t
End Type
Type formation
	Field ship.ship[maxformshp],leader.ship,freq,designation
	Field x,y,angle,roll,state,targetx,targety,role,spread,target.formation,nofire,detected[maxfreqs],nodistcheck,istarget
	Field msg_id,msg_timer,msg_CLI.ship,msg_CLE.ship,msg_callback.ship
End Type
Type turret
	Field ship.ship,target.ship
	Field id,pos,anglepos,angle#,target_angle#,interceptcheck,targetcheck,ammo,reload_gun,barrel,multi
End Type
Type exhaust
	Field x#,y#,s#,t#,frame#
End Type
Type bullet
	Field gun.weap_gun_stats,owner.ship
	Field x#,y#,s#,t#,frame#,frame_end,particle_t,freq,life_t
End Type
Type particle
	Field x#,y#,col_x#,col_y
End Type
Type bomb
	Field bmb.weap_bmb_stats,owner.ship
	Field x#,y#,s#,t#,frame#,frame_end,trail_t,freq,life_t,trigger.ship,trigger_t,trigger_lastdist
End Type
Type trail
	Field x#,y#,frame#,frame_end
End Type
Type explosion
	Field img,x#,y#,frame#,frame_end
End Type
Type debris_m
	Field img,x#,y#,frame#,frame_end,s#,t#
End Type
Type debris_s
	Field img,x#,y#,frame#,frame_end
End Type
Type chatmessage
	Field content$,col,id
End Type
Type FrameRate
	Field TargetFPS#,SpeedFactor#
	Field FPS#
	Field CurrentTicks
	Field FrameDelay
End Type

;----------------------------------------------------
;data types
Type ship_stats
	Field weap_gun.weap_gun_stats,weap_bmb.weap_bmb_stats,turret.turret_stats[maxturrets]
	Field img,junk,accel#,topspeed#,burnspeed#,burnaccel#,burnfuel,burnregen#,turnspeed#,hp,shield,recharge,bombs
	Field standoff
	Field capship,carrier,turret_pos[maxturrets],turret_angle[maxturrets]
End Type
Type weap_gun_stats
	Field frame,dmg,speed,life,icon,multi,ammo,rof,reload,trail,rof_multi,sequenced,barrels
	Field angle_start[maxbarrels],angle_travel[maxbarrels]
End Type
Type weap_bmb_stats
	Field frame,dmg,speed,life,icon,proxy,recoil,rof,trail,timer,radius
End Type
Type turret_stats
	Field weap_gun.weap_gun_stats
	Field img,turnspeed#
End Type

;----------------------------------------------------
Global FL.FrameRate=New FrameRate
FL\TargetFPS#=35
FL\FrameDelay=MilliSecs()

Include "inc\TimerSystem 4c.bb"

SuperArcade=False

Dim hr.heuristics(maxfreqs)
hr(0)=New heuristics
hr(1)=New heuristics

;----------------------------------------------------
.SETUP_SCEN
If DebugLoad Then Print "Setting up scenario"
;warbird
wg.weap_gun_stats=New weap_gun_stats
wg\frame=8					;bullet image
wg\dmg=2500					;damage
wg\speed=12					;speed
wg\life=2000				;projectile lifetime
wg\icon=2					;UI Icon
wg\multi=0					;has multifire mode?
wg\ammo=1					;max ammo
wg\rof=1000					;rate of fire between shots
wg\reload=2000				;reload time when ammo is depleted
wg\trail=9					;particle trail color Y index from color array

ss.ship_stats=New ship_stats
ss\img=ship_wb
ss\junk=junk_wb
ss\accel#=0.05
ss\topspeed#=4
ss\turnspeed#=4.5
ss\weap_gun=wg
ss\weap_bmb=Null
ss\bombs=0
ss\hp=800
ss\shield=1500
ss\recharge=25
ss\standoff=screenx/4
ss\burnspeed#=10
ss\burnaccel#=0.2
ss\burnfuel=30
ss\burnregen=.8
ss\capship=False

;player formation
fm.formation=New formation
	fm\x=2000
	fm\y=500
	fm\spread=100
	fm\freq=0
	sh.ship=Newship(fm\x,fm\y+fm\spread,270,ss,fm)
    sh\designation=1
	fm\ship[0]=sh
	Global pl.player=New player
		pl\x#=2000
		pl\y#=600
		pl\ship=sh
		pl\key_left=203
		pl\key_right=205
		pl\key_up=200
		pl\key_down=208
		pl\key_fireA=29
		pl\key_fireB=15
		pl\key_multi=211
		pl\key_afterburner=42
		pl\hlthbar_y=4

	For shp=1 To maxformshp
		sh.ship=Newship(fm\x+(fm\spread*table_sinA(90*shp)),fm\y+(fm\spread*table_cosA(90*shp)),270,ss,fm)
		sh\designation=shp+1
		np.npc=New npc
			np\ship=sh
		fm\ship[shp]=sh
	Next
	fm\leader=pl\ship
	fm\role=role_fighter
	fm\designation=0

;warbird formation #2
fm.formation=New formation
	fm\x=2000
	fm\y=-500
	fm\spread=100
	fm\freq=0
	For shp=0 To maxformshp
		sh.ship=Newship(fm\x+(fm\spread*table_sinA(90*shp)),fm\y+(fm\spread*table_cosA(90*shp)),270,ss,fm)
		sh\designation=shp+1
		np.npc=New npc
			np\ship=sh
		fm\ship[shp]=sh
	Next
	fm\leader=fm\ship[0]
	fm\role=role_fighter
	fm\designation=1

;enemy warbird formation #1
fm.formation=New formation
	fm\x=-2000
	fm\y=500
	fm\spread=100
	fm\freq=1
	For shp=0 To maxformshp
		sh.ship=Newship(fm\x+(fm\spread*table_sinA(90*shp)),fm\y+(fm\spread*table_cosA(90*shp)),90,ss,fm)
		sh\designation=shp+1
		np.npc=New npc
			np\ship=sh
		fm\ship[shp]=sh
	Next
	fm\leader=fm\ship[0]
	fm\role=role_fighter
	fm\designation=0

;enemy warbird formation #2
fm.formation=New formation
	fm\x=-2000
	fm\y=-500
	fm\spread=100
	fm\freq=1
	For shp=0 To maxformshp
		sh.ship=Newship(fm\x+(fm\spread*table_sinA(90*shp)),fm\y+(fm\spread*table_cosA(90*shp)),90,ss,fm)
		sh\designation=shp+1
		np.npc=New npc
			np\ship=sh
		fm\ship[shp]=sh
	Next
	fm\leader=fm\ship[0]
	fm\role=role_fighter
	fm\designation=1

;javelin
wg.weap_gun_stats=New weap_gun_stats
wg\frame=0
wg\dmg=250
wg\speed=6
wg\life=2000
wg\icon=0
wg\multi=False
wg\ammo=15
wg\rof=80
wg\reload=3500
wg\trail=7
wg\sequenced=True
wg\barrels=3
wg\angle_start[1]=4				;bullet spread
wg\angle_start[3]=356
wg\angle_travel[1]=1
wg\angle_travel[3]=359

wb.weap_bmb_stats=New weap_bmb_stats
wb\frame=0
wb\dmg=3250
wb\speed=8
wb\life=4000
wb\icon=24
wb\proxy=80
wb\radius=100
wb\timer=500
wb\recoil=1
wb\rof=2000
wb\trail=0

ss.ship_stats=New ship_stats
ss\img=ship_jv
ss\junk=junk_jv
ss\accel#=0.1
ss\topspeed#=3.5
ss\turnspeed#=2
ss\weap_gun=wg
ss\weap_bmb=wb
ss\bombs=16
ss\hp=1000
ss\shield=1000
ss\recharge=15
ss\standoff=screenx
ss\capship=False
ss\burnspeed#=6.5
ss\burnaccel#=0.2
ss\burnfuel=100
ss\burnregen=.6

;javelin formation
fm.formation=New formation
	fm\x=2500
	fm\y=-700
	fm\spread=150
	fm\freq=0
	For shp=0 To maxformshp
		sh.ship=Newship(fm\x+(fm\spread*table_sinA(90*shp)),fm\y+(fm\spread*table_cosA(90*shp)),270,ss,fm)
		sh\designation=shp+1
		np.npc=New npc
			np\ship=sh
		fm\ship[shp]=sh
	Next
	fm\leader=fm\ship[0]
	fm\role=role_fighter
	fm\designation=2

;enemy javelin formation
fm.formation=New formation
	fm\x=-2500
	fm\y=700
	fm\spread=150
	fm\freq=1
	For shp=0 To maxformshp
		sh.ship=Newship(fm\x+(fm\spread*table_sinA(90*shp)),fm\y+(fm\spread*table_cosA(90*shp)),90,ss,fm)
		sh\designation=shp+1
		np.npc=New npc
			np\ship=sh
		fm\ship[shp]=sh
	Next
	fm\leader=fm\ship[0]
	fm\role=role_fighter
	fm\designation=2

;leviathan
wb.weap_bmb_stats=New weap_bmb_stats
wb\frame=10
wb\dmg=8000
wb\speed=7
wb\life=5000
wb\icon=19
wb\proxy=0
wb\radius=50
wb\timer=0
wb\recoil=3
wb\rof=5500
wb\trail=10

ss.ship_stats=New ship_stats
ss\img=ship_lv
ss\junk=junk_lv
ss\accel#=0.04
ss\topspeed#=2
ss\turnspeed#=1.3
ss\weap_gun=Null
ss\weap_bmb=wb
ss\bombs=6
ss\hp=2000
ss\shield=1500
ss\recharge=15
ss\standoff=screenx
ss\capship=False

;leviathan formation
fm.formation=New formation
	fm\x=2500
	fm\y=700
	fm\spread=150
	fm\freq=0
	For shp=0 To maxformshp
		sh.ship=Newship(fm\x+(fm\spread*table_sinA(90*shp)),fm\y+(fm\spread*table_cosA(90*shp)),270,ss,fm)
		sh\designation=shp+1
		np.npc=New npc
			np\ship=sh
		fm\ship[shp]=sh
	Next
	fm\leader=fm\ship[0]
	fm\role=role_bomber
	fm\designation=3

;enemy leviathan formation
fm.formation=New formation
	fm\x=-2500
	fm\y=-700
	fm\spread=150
	fm\freq=1
	For shp=0 To maxformshp
		sh.ship=Newship(fm\x+(fm\spread*table_sinA(90*shp)),fm\y+(fm\spread*table_cosA(90*shp)),90,ss,fm)
		sh\designation=shp+1
		np.npc=New npc
			np\ship=sh
		fm\ship[shp]=sh
	Next
	fm\leader=fm\ship[0]
	fm\role=role_bomber
	fm\designation=3

;mothership
wb.weap_bmb_stats=New weap_bmb_stats
wb\frame=20
wb\dmg=18000
wb\speed=6
wb\life=6000
wb\icon=20
wb\proxy=0
wb\radius=150
wb\timer=0
wb\recoil=0
wb\rof=2000
wb\trail=20

ss.ship_stats=New ship_stats
ss\img=mothership
ss\junk=junk_wb
ss\accel#=0.01
ss\topspeed#=1.5
ss\turnspeed#=0.15
ss\weap_gun=Null
ss\weap_bmb=wb
ss\bombs=10
ss\hp=15000
ss\shield=30000
ss\recharge=1000
ss\capship=True
ss\carrier=True

;point defense turret
wg.weap_gun_stats=New weap_gun_stats
wg\frame=4
wg\dmg=800
wg\speed=10
wg\life=2000
wg\icon=1
wg\multi=False
wg\ammo=10
wg\rof=400
wg\reload=2500
wg\trail=8

ts.turret_stats=New turret_stats
ts\weap_gun=wg
ts\img=turret2a
ts\turnspeed#=1.6

;turbolaser turret
wg.weap_gun_stats=New weap_gun_stats
wg\frame=20
wg\dmg=2000
wg\speed=2
wg\life=5000
wg\icon=10
wg\multi=False
wg\ammo=50
wg\rof=400
wg\reload=2500
wg\trail=7

ts2.turret_stats=New turret_stats
ts2\weap_gun=wg
ts2\img=turret2
ts2\turnspeed#=.5

ss\turret[0]=ts
ss\turret_pos[0]=40
ss\turret_angle[0]=180

ss\turret[1]=ts2
ss\turret_pos[1]=40
ss\turret_angle[1]=54

ss\turret[2]=ts2
ss\turret_pos[2]=40
ss\turret_angle[2]=306

;freq 0 mothership
fm.formation=New formation
	fm\freq=0
	sh.ship=Newship(2250,0,270,ss,fm)
	sh\designation=0
	hr(0)\mother=sh
	np.npc=New npc
		np\ship=sh
	fm\x=sh\x
	fm\y=sh\y
	fm\ship[0]=sh
	fm\role=role_capship
	fm\leader=sh

;freq 1 mothership
fm.formation=New formation
	fm\freq=1
	sh.ship=Newship(-2250,0,90,ss,fm)
	sh\designation=0
	hr(1)\mother=sh
	np.npc=New npc
		np\ship=sh
	fm\x=sh\x
	fm\y=sh\y
	fm\ship[0]=sh
	fm\role=role_capship
	fm\leader=sh
	fm\designation=0

;escort
ss.ship_stats=New ship_stats
ss\img=escort
ss\junk=junk_wb
ss\accel#=0.01
ss\topspeed#=1.8
ss\turnspeed#=0.2
ss\weap_gun=Null
ss\weap_bmb=wb
ss\bombs=10
ss\hp=10000
ss\shield=10000
ss\recharge=1000
ss\capship=True

ss\turret[0]=ts
ss\turret_pos[0]=0
ss\turret_angle[0]=0

;freq 0 escort
fm.formation=New formation
	fm\freq=0
	sh.ship=Newship(2200,200,270,ss,fm)
	sh\designation=1
	np.npc=New npc
		np\ship=sh
	fm\x=sh\x
	fm\y=sh\y
	fm\ship[0]=sh
	fm\role=role_capship
	fm\leader=sh
	fm\designation=1

;freq 1 escort
fm.formation=New formation
	fm\freq=1
	sh.ship=Newship(-2200,-200,90,ss,fm)
	sh\designation=1
	np.npc=New npc
		np\ship=sh
	fm\x=sh\x
	fm\y=sh\y
	fm\ship[0]=sh
	fm\role=role_capship
	fm\leader=sh
	fm\designation=1

Function Newship.ship( x#,y# ,angle#, ship.ship_stats, fm.formation )
	Local sh.ship=New ship
	sh\x=x#
	sh\y=y#
	sh\angle=angle
	sh\ship=ship
	sh\freq=fm\freq
	sh\formation=fm

	sh\hp=ship\hp
	sh\shield=ship\shield
	sh\recharge_t=NewTimer(rechargedelay,True)
	sh\fuel#=ship\burnfuel
	sh\reburn_t=NewTimer(rechargedelay,True)

	If ship\weap_gun<>Null Then
		Local wg.weap_gun_stats=ship\weap_gun
		sh\ammo=wg\ammo
        sh\reload_gun=NewTimer(wg\rof,True)
	EndIf
	If ship\weap_bmb<>Null Then
		Local wb.weap_bmb_stats=ship\weap_bmb
		sh\bombs=ship\bombs
        sh\reload_bmb=NewTimer(wb\rof,True)
	EndIf
    
	sh\docked_t=NewTimer(reloaddelay,True)
	sh\exhaust_t=NewTimer(exhaustdelay,False)

	For a=0 To maxturrets
		If ship\turret[a]<>Null Then
			tu.turret=New turret
				tu\ship=sh
				tu\id=a
				tu\target_angle=Rand(0,359)

			Local ts.turret_stats=ship\turret[a]
			wg.weap_gun_stats=ts\weap_gun
			tu\reload_gun=NewTimer(wg\rof,True)
		EndIf
	Next

	Return sh
End Function

;----------------------------------------------------
.set_initialheading
;calculate center point for each freq
Dim centerp(maxfreqs,2)
For fm.formation=Each formation
	centerp(fm\freq,0)=centerp(fm\freq,0)+fm\x	;center x
	centerp(fm\freq,1)=centerp(fm\freq,1)+fm\y	;center y
	centerp(fm\freq,2)=centerp(fm\freq,2)+1		;counter
Next
;set average
For a=0 To maxfreqs
	If centerp(a,2)<>0 Then
		centerp(a,0)=centerp(a,0)/centerp(a,2)
		centerp(a,1)=centerp(a,1)/centerp(a,2)
	EndIf
Next
;get centerpoint of all centerpoints
centerx=centerp(0,0)
centery=centerp(0,1)
For a=1 To maxfreqs
	centerx=centerx+centerp(a,0)
	centery=centery+centerp(a,1)
Next
centerx=centerx/(maxfreqs+1)
centery=centery/(maxfreqs+1)

For fm.formation=Each formation
	fm\targetx=centerx+(fm\x-centerp(fm\freq,0))
	fm\targety=centery+(fm\y-centerp(fm\freq,1))
	fm\state=state_seek
	For a=0 To maxformshp
		If fm\ship[a]<>Null Then
			sh.ship=fm\ship[a]
			sh\target_angle=VectorAngle(fm\targetx+(sh\x-fm\x)-sh\x,fm\targety+(sh\y-fm\y)-sh\y)

			;update total ships counters
			If SuperArcade=False Then
				pl\loss=pl\loss+1*(sh\freq=pl\freq)
				pl\wins=pl\wins+1*(sh\freq<>pl\freq)
			EndIf
		EndIf
	Next

	;set heuristics (track amount of fighter/bomber/capship formations each side has left,etc)
	hr(fm\freq)\formations[fm\role]=hr(fm\freq)\formations[fm\role]+1
Next

;note: (only works for two freqs ATM)
;note: need to protect from dividebyzero
For a=0 To maxfreqs
	For b=0 To maxroles
		;track available formations (in seek state), all at start
		hr(a)\available[b]=hr(a)\formations[b]
		;track hostile formations that are not yet targeted, all at start
		hr(a)\targets[b]=hr(Not a)\formations[b]
	Next
	;set initial formations available for each type
	;initial targeting excludes bombers, fighters get priority
	;fighters vs fighters
	hr(a)\assignment[role_fighter]=Ceil( Float(hr(a)\available[role_fighter]) / hr(Not a)\formations[role_fighter] )
	;bombers and capships vs capships
	hr(a)\assignment[role_capship]=Ceil( (Float(hr(a)\available[role_bomber])+Float(hr(a)\available[role_capship])) / hr(Not a)\formations[role_capship])
Next

;----------------------------------------------------
.create_starfield
If DebugLoad Then Print "Creating backdrops"
SeedRnd MilliSecs()
Dim backdrop(2)
backdrop(0)=CreateImage(screenx*2,screeny*2)
SetBuffer ImageBuffer(backdrop(0))
Color 100,100,100
For star=0 To screeny
	Rect Rand(screenx*2),Rand(screeny*2),1,1
Next
DrawBlock bg_misc(Rand(max_misc-1)),Rand(screenx),Rand(screeny)

backdrop(1)=CreateImage(screenx*1,screeny*1)
SetBuffer ImageBuffer(backdrop(1))
Color 200,200,200
For star=0 To screeny/12
	Rect Rand(screenx*1),Rand(screeny*1),1,1
Next
For bg=0 To 1
	DrawImage bg_star(Rand(max_star-1)),Rand(screenx*1-21),Rand(screeny*1-21)
Next

backdrop(2)=CreateImage(screenx,screeny)
SetBuffer ImageBuffer(backdrop(2))
For bg=0 To 1
	DrawImage bg_star(Rand(max_star-1)),Rand(screenx-21),Rand(screeny-21)
Next
Global backdroploaded = True

;----------------------------------------------------
; interlace overlay
If DebugLoad Then Print "Creating overlays"
Local interlace_screen=CreateImage(screenx,screeny)
MaskImage interlace_screen , 255,0,255
Color 255,0,255
SetBuffer ImageBuffer(interlace_screen)
For y=0 To screeny-1 Step 2
    Rect 0,y , screenx,1
Next
Const interlace_interval_normal=1000
Const interlace_interval_turbo=25
Local interlace_lasttime=MilliSecs()
Local interlace_offset=0
Local interlace_enabled=False
Local interlace_turbo=True
Local interlace_interval=interlace_interval_turbo

Local dupli_screen=CreateImage(screenx,screeny)

;----------------------------------------------------
Local CrawlLock=False  ; toggle with C
Const CrawlLockSpeed=50  ; ms delay
Local VSync=True  ; toggle with V
Local DebugTargets=False   ; toggle with tilde/backquote
Global HostileEnemy=True  ; toggle with '1'
Local InstantTurnNPC=False  ; toggle with '4'
Local GodMode=False  ; toggle with '5'
Local NoDebris=False

Global chatmessages
Global gonemessages

;generate starting motivational message
CreateMessage(msg_motivate,hr(pl\freq)\mother,Null,Null)

SetBuffer BackBuffer()
DebugLog "Video memory used: "+(startmem-AvailVidMem())+" bytes"

Local currenttrack=Rand(0,max_music)
Local music = BASS_MIDI_StreamCreateFile(0,battlemusdir+playlist$(index(currenttrack))+track$(currenttrack),0,0,0,0) ; we load a midi file
If Not BASS_ChannelPlay (music,0) Then DebugLog "Midi file not ready! "

;----------------------------------------------------
;----------------------------------------------------
SetFont FontMedium
.main_battle_standard
While Not KeyHit(1)
	;fps limiter
	FL\CurrentTicks=MilliSecs()
	FL\SpeedFactor=(FL\CurrentTicks - FL\FrameDelay)/(1000/FL\TargetFPS)
	If FL\SpeedFactor<=0 Then FL\SpeedFactor=0.00000000001    
	FL\FPS=FL\TargetFPS/FL\SpeedFactor    
	FL\FrameDelay=FL\CurrentTicks

    currentcol#=currentcol#+4*FL\SpeedFactor										;advance current colour
	If currentcol#>127 Then currentcol#=0
    
    TileBlock backdrop(0),-pl\x#/16,-pl\y#/32										;tile scrolling background
    TileImage backdrop(1),7-pl\x#/8,-pl\y#/8
    TileImage backdrop(2),23-pl\x#/4,-pl\y#/4
	Text 0,200,FL\SpeedFactor+"x"

	MilliSecs=FL\CurrentTicks
	
	ascii = GetKey()
	If ascii > 0
		Select ascii
			Case 67,99  ; C/c  (crawl lock)
				CrawlLock = Not CrawlLock
			Case 77,109  ; M/m  (next music)
				Gosub next_music
			Case 86,118  ; V/v  (vertical sync)
				VSync = Not VSync
		End Select
	End If
	
    If KeyHit(41)  ; backquote/tilde key (debug)
        ; toggle debug mode
        DebugTargets = Not DebugTargets
    End If
    If KeyHit(2)  ; '1' (enemyfire)
        ; toggle enemy firing
        HostileEnemy = Not HostileEnemy
    End If
    If KeyHit(3)  ; '2' (interlace)
        ; toggle (doubled) interlaced mode
        interlace_enabled = Not interlace_enabled
    End If
    If KeyHit(4)  ; '3' (interlace interval)
        ; toggle slow/faster interlace refresh
        interlace_turbo = Not interlace_turbo
        Select interlace_turbo
            Case False
                interlace_interval = interlace_interval_normal
            Case True
                interlace_interval = interlace_interval_turbo
        End Select
    End If
    If KeyHit(5)  ; '4' (fast npc turning)
        InstantTurnNPC = Not InstantTurnNPC
    End If
    If KeyHit(6)  ; '5' (invincibility)
        GodMode = Not GodMode
    End If
	If KeyHit(7)
		NoDebris = Not NoDebris
	EndIf
	If KeyHit(74)	;'-' previous ship
		sh.ship=pl\ship
		Repeat
			If sh=First ship
				sh.ship=Last ship
			Else
				sh.ship=Before sh
			EndIf
		Until sh\freq=pl\freq
		For np.npc=Each npc
			If np\ship=sh Then
				np\ship=pl\ship
				Exit
			EndIf
		Next
		pl\ship=sh
	EndIf
	If KeyHit(78)	;'+' next ship
		sh.ship=pl\ship
		Repeat
			If sh=Last ship
				sh.ship=First ship
			Else
				sh.ship=After sh
			EndIf
		Until sh\freq=pl\freq
		For np.npc=Each npc
			If np\ship=sh Then
				np\ship=pl\ship
				Exit
			EndIf
		Next
		pl\ship=sh
	EndIf
	If KeyHit(57) Then Goto map_view
    
	Gosub update_formations
	Gosub update_debris_m
	If NoDebris=False Then Gosub update_debris_s
	Gosub update_exhaust
	Gosub update_particles
	Gosub update_bullets
	Gosub update_trails
	Gosub update_bombs
	Gosub update_player
	Gosub update_npc
	Gosub update_turret
	Gosub update_explosion
	If interlace_enabled Then Gosub apply_interlace
	Gosub update_UI
	Gosub update_music

    Color 0,192,64
    Text 0,0 , "Hostile enemies: "+Mid( "FalseTrue" , 1+HostileEnemy*5 , 5 )+" <1>"
    Text 0,15 , "Debug mode: "+Mid( "FalseTrue" , 1+DebugTargets*5 , 5 )+" <~>"
    Text 0,30 , "Interlacing: "+Mid( "FalseTrue" , 1+interlace_enabled*5 , 5 )+" <2>"
    Text 0,45 , "Interlace mode: "+Mid( "Slow Turbo" , 1+interlace_turbo*5 , 5 )+" <3>"
    Text 0,60 , "NPC direct aim: "+Mid( "FalseTrue" , 1+InstantTurnNPC*5 , 5 )+" <4>"
    Text 0,75 , "God mode: "+Mid( "FalseTrue" , 1+GodMode*5 , 5 )+" <5>"

    If DebugTargets  ; backquote (debug)
		DrawGrid screenxmid-pl\x,screenymid-pl\y , screenx/4,screeny/4 , screenx,screeny
	EndIf
	
	usFPS
	
	Flip VSync
    Delay 1  ; lowers cpu usage on multicore systems
	If CrawlLock
		Delay CrawlLockSpeed
	End If
Wend

ScreenMessage "UNLOADING"
BASS_ChannelStop music

End

;----------------------------------------------------
;----------------------------------------------------
.update_formations
For fm.formation=Each formation
	fm\x=0												;update center position of formation
	fm\y=0
	fm\angle=0											;average angle of formation (for map view)
	fm\roll=0											;average roll of formation (same)
	counter=0											;number of ships in fm
	bombcount=0											;bomb counter
	For a=0 To maxformshp
		If fm\ship[a]<>Null Then
			sh.ship=fm\ship[a]
			fm\x=fm\x+sh\x
			fm\y=fm\y+sh\y
			fm\angle=fm\angle+sh\angle
			fm\roll=fm\roll+sh\roll
			counter=counter+1
			bombcount=bombcount+sh\bombs
		EndIf
	Next
	fm\x=fm\x/counter									;average calculated items
	fm\y=fm\y/counter
	fm\angle=fm\angle/counter
	fm\roll=fm\roll/counter
	ss.ship_stats=sh\ship
	If ss\weap_bmb=Null Then bombcount=-1				;set bomb counter to -1 if shiptype has no bomb launcher

	;create delayed message
	If TimerDone(fm\msg_timer) Then
		;check if referenced ships are still alive before sending msg
		sendmessage=True
		sh.ship=fm\msg_CLI
		If sh=Null Then sendmessage=False
		If fm\msg_CLE<>Null Then
			sh.ship=fm\msg_CLE
			If sh<>Null Then sendmessage=False
		EndIf
		If fm\msg_callback<>Null Then
			sh.ship=fm\msg_callback
			If sh<>Null Then sendmessage=False
		EndIf
		;call createmessage
		If sendmessage=True Then CreateMessage(fm\msg_id,fm\msg_CLI,fm\msg_CLE,fm\msg_callback)
		;cleanup
		DeleteTimer(fm\msg_timer)
		fm\msg_id=0
		fm\msg_CLI=Null
		fm\msg_CLE=Null
		fm\msg_callback=Null
	EndIf

	Select fm\state
	Case state_goto
		fm\nofire=True
		fm\nodistcheck=True

		;destination reached?
		If fm\x>fm\targetx-5 And fm\x<fm\targetx+5 And fm\y>fm\targety-5 And fm\y<fm\targety+5 Then
			;check for nearby target
			fm\target=GetNearestTargetFm(fm)
			If fm\target<>Null Then
				fm2.formation=fm\target
				Select fm2\role				;check nearest target role
				Case role_capship				;target is capital ship
					If bombcount=0 Then				;formation has no bombs left (if fm has no bomb type weapon bombs will be -1)
						fm\state=state_return
					EndIf
				Case role_fighter,role_bomber	;target is fighter/bomber
					If ss\weap_gun=Null And bombs<=0 Then		;formation's ship type has no guns, and no bombs
						fm\state=state_return
					EndIf
				End Select
				If fm2\istarget=False And fm\state<>state_return Then	;one less formation to target?
					hr(fm\freq)\targets[fm\role]=hr(fm\freq)\targets[fm2\role]-1
					set_heuristicsassignment(fm\freq,fm2\role)
					fm2\istarget=True
				EndIf
			ElseIf bombcount=0
				;no targets found - out of bombs
				fm\state=state_return
			Else
				;no targets found
				fm\state=state_seek
				hr(fm\freq)\available[fm\role]=hr(fm\freq)\available[fm\role]+1
			EndIf
		EndIf
	;	For a=0 To 3
	;		If fm\ship[a]<>Null Then
	;			sh.ship=fm\ship[a]
	;			sh\target_angle#=vectorangle((fm\targetx+fm\x-sh\x)-sh\x,(fm\targety-+fm\y-sh\y)-sh\y)
	;		EndIf
	;	Next
	Case state_seek
		fm\nofire=True
		fm\nodistcheck=True
	Case state_attack
		fm\nofire=Not HostileEnemy
		fm\nodistcheck=False
	;	For a=0 To 3
	;		If fm\ship[a]<>Null Then
	;			For b=0 To 3
	;				If a<>b And fm\ship[b]<>Null Then
	;					sh.ship=fm\ship[a]
	;					sh2.ship=fm\ship[b]
	;					If vectordistance(sh\x-sh2\x,sh\y-sh2\y)<fm\spread Then
	;						sh\target_angle#=sh\target_angle#-vectorangle(sh\x-sh2\x,sh\y-sh2\y)
	;					EndIf
	;				EndIf
	;			Next
	;		EndIf
	;	Next
	Case state_regroup
		fm\nofire=True
		fm\nodistcheck=True
		fm\targetx=fm\x
		fm\targety=fm\y
		For a=0 To maxformshp
			If fm\ship[a]<>Null Then
				sh.ship=fm\ship[a]
				sh\target_angle=VectorAngle(sh\x-(fm\x+fm\spread*table_sinA(90*a)),sh\y-(fm\y+fm\spread*table_cosA(90*a)))
			EndIf
		Next
		fm\state=state_goto
		If fm\freq=pl\freq And fm\role<>role_capship Then CreateMessage(msg_done,fm\leader,Null,Null)
	Case state_return
		fm\nofire=True
		fm\nodistcheck=True
		If hr(fm\freq)\mother<>Null Then
			sh.ship=hr(fm\freq)\mother
			fm\targetx=sh\x
			fm\targety=sh\y
			For a=0 To maxformshp
				If fm\ship[a]<>Null Then
					sh2.ship=fm\ship[a]
					sh\target_angle=VectorAngle(sh2\x-sh\x,sh2\y-sh\y)
				EndIf
			Next
		EndIf
	End Select

	;check for hostile formations within radar range
	For fm2.formation=Each formation
		If fm2\freq<>fm\freq And fm2\detected[fm\freq]=False And RectsOverlap(fm2\x-18,fm2\y-18,36,36,fm\x-radarrange/2,fm\y-radarrange/2,radarrange,radarrange)
			;set fm2 as detected
			fm2\detected[fm\freq]=True

			;go through alotted amount of formations
			tmpheuristic=hr(fm\freq)\assignment[fm2\role]
			If tmpheuristic>0 Then
				For a=1 To tmpheuristic
					update_attackprofile(fm2,fm)
				Next
				;one less formation to target
				hr(fm\freq)\targets[fm2\role]=hr(fm\freq)\targets[fm2\role]-1
				set_heuristicsassignment(fm\freq,fm2\role)
	
				;create spotted message
				If fm\freq=pl\freq And fm\target<>fm2 Then
					CreateMessage(msg_detect,fm\leader,fm2\leader,Null)
				EndIf
	
				fm2\istarget=True
			EndIf
			;Exit
		EndIf
	Next
Next

Return

;----------------------------------------------------
;----------------------------------------------------
.update_player
sh.ship=pl\ship
ss.ship_stats=sh\ship
If sh\dead=True Then
	;check if ship is docked
	sh2.ship=sh\docked
	If sh2<>Null Then
		;ship is docked
		pl\x=sh2\x
		pl\y=sh2\y
		If sh\bombs<ss\bombs And TimerDone(sh\docked_t) Then		;rearm bombs
			sh\bombs=sh\bombs+1
			StartTimer(sh\docked_t)
		EndIf
		If KeyDown(pl\key_up) Or KeyDown(pl\key_down)				;undock
			sh\angle#=sh2\angle
			sh\x=sh2\x
			sh\y=sh2\y
			sh\thrust=1
			sh\s=sh2\s
			sh\t=sh2\t
			sh\docked=Null
			sh\dead=False
		EndIf
		Return
	Else
		;ship is not docked but dead
		If GodMode=True Then		;cheater
			sh\dead=False
		Else
			Gosub remove_ship		;remove ship & get new ship id or end game
			sh.ship=pl\ship
			ss.ship_stats=sh\ship
			If ss\weap_gun<>Null Then
				If sh\ammo>wg\ammo/2	;reset ammo meter bar color (hlthbar is a bit misleading, sorry)
					pl\hlthbar_y=4
				ElseIf sh\ammo>wg\ammo/4
					pl\hlthbar_y=5
				Else
					pl\hlthbar_y=6
				EndIf
			EndIf
		EndIf
	EndIf
EndIf
wg.weap_gun_stats=ss\weap_gun
wb.weap_bmb_stats=ss\weap_bmb

Turn=KeyDown(pl\key_right)-KeyDown(pl\key_left)			;determine turn direction
sh\angle#=sh\angle#+ss\turnspeed#*Turn*FL\SpeedFactor	;apply rotation
sh\angle = RangeFloat( sh\angle , 359 )

If KeyDown( pl\key_up )									;thrust forward
    sh\thrust# = sh\thrust# + 1 * FL\SpeedFactor
ElseIf KeyDown( pl\key_down)							;thrust backward
    sh\thrust# = sh\thrust# - 1 * FL\SpeedFactor
Else													;no thrust
    If sh\thrust > -1 * FL\SpeedFactor And sh\thrust < 1 * FL\SpeedFactor
        sh\thrust = 0
    Else
        sh\thrust = sh\thrust - Sgn(sh\thrust) * FL\SpeedFactor
    End If
End If
sh\thrust = CapFloat( sh\thrust , -maxthrust, maxthrust )

If KeyDown(pl\key_afterburner) And sh\fuel#>0 And sh\thrust Then		;afterburner active
	;accelerate ship based on angle
	speedx# = ss\burnaccel# * sh\thrust * table_sin( sh\angle# ) / maxthrust
	speedy# = ss\burnaccel# * sh\thrust * table_cos( sh\angle# ) / maxthrust
	
	; add speedX and speedY to ship velocities
	sh\s# = sh\s# + speedx#
	sh\t# = sh\t# - speedy#
	
	; circular speed limiter
	ship_speed# = VectorDistance( sh\s#,sh\t# )
	If ship_speed > ss\burnspeed
	    ship_speed = ss\burnspeed
	    ship_heading# = VectorAngle( sh\s#,sh\t# )
	    sh\s# = VectorX( ship_speed,ship_heading# )
	    sh\t# = VectorY( ship_speed,ship_heading# )
	End If

	sh\fuel#=sh\fuel#-1*FL\SpeedFactor#
	If TimerState(sh\reburn_t)=0 Then ResetTimer(sh\reburn_t)
Else																	;normal thrust
	;accelerate ship based on angle
	speedx# = ss\accel# * sh\thrust * table_sin( sh\angle# ) / maxthrust
	speedy# = ss\accel# * sh\thrust * table_cos( sh\angle# ) / maxthrust
	
	; add speedX and speedY to ship velocities
	sh\s# = sh\s# + speedx#
	sh\t# = sh\t# - speedy#

	; circular speed limiter
	ship_speed# = VectorDistance( sh\s#,sh\t# )
	If ship_speed > ss\topspeed
	    ship_speed = ss\topspeed
	    ship_heading# = VectorAngle( sh\s#,sh\t# )
	    sh\s# = VectorX( ship_speed,ship_heading# )
	    sh\t# = VectorY( ship_speed,ship_heading# )
	End If
EndIf

;apply velocity to player position
sh\x#=sh\x#+sh\s#*FL\SpeedFactor#
sh\y#=sh\y#+sh\t#*FL\SpeedFactor#

If ss\weap_gun<>Null Then															;reload/fire guns
	If sh\ammo=0																	;reload guns
		If TimerDone(sh\reload_gun) Then
			PauseTimer(sh\reload_gun)
			sh\ammo=wg\ammo
			pl\hlthbar_y=4
		EndIf
	ElseIf TimerState(sh\reload_gun)=1 Then											;recharge guns
		If TimerDone(sh\reload_gun) Then PauseTimer(sh\reload_gun)
	ElseIf KeyDown(pl\key_fireA)													;fire guns!
		Gosub CreateBullet
		If sh\ammo>wg\ammo/2								;set ammo meter bar color (hlthbar is a bit misleading, sorry)
			pl\hlthbar_y=4
		ElseIf sh\ammo>wg\ammo/4
			pl\hlthbar_y=5
		Else
			pl\hlthbar_y=6
		EndIf
	EndIf
EndIf

If ss\weap_bmb<>Null And sh\bombs<>0 Then
	If TimerState(sh\reload_bmb)=1 Then												;recharge bombs
		If TimerDone(sh\reload_bmb) Then ResetTimer(sh\reload_bmb,0,True)
	ElseIf KeyDown(pl\key_fireB)													;fire bombs!
		Gosub CreateBomb
	EndIf
EndIf

If TimerDone(sh\recharge_t) Then													;recharge shields
	sh\shield=sh\shield+ss\recharge
	If sh\shield>=ss\shield Then
		sh\shield=ss\shield
		PauseTimer(sh\recharge_t)
	Else
		ResetTimer(sh\Recharge_t)
	EndIf
EndIf

If TimerDone(sh\reburn_t) Then														;recharge afterburner
	sh\fuel#=sh\fuel+ss\burnregen
	If sh\fuel>=ss\burnfuel Then
		sh\fuel=ss\burnfuel
		PauseTimer(sh\reburn_t)
	Else
		ResetTimer(sh\reburn_t)
	EndIf
EndIf

If ss\capship=True Then
	DrawImage ss\img,screenxmid,screenymid,Floor(sh\angle#/9)
Else
	;calculate 'roll'
	aV#=ATan2(sh\s#,-sh\t#)
	difference=AngleDifference(sh\angle#,aV#)
	sh\roll#=Sin(difference)*5*sh\thrust/maxthrust

	;create thruster flames
	If sh\thrust<>0 And TimerDone(sh\exhaust_t) Then Gosub CreateExhaust

	DrawImage ss\img,screenxmid,screenymid,200+Floor(sh\angle#/9)+40*Int(sh\roll#)
	If DebugTargets  ; backquote (debug)
	    x=screenxmid
	    y=screenymid
	    Color 0,255,255
	    Oval x-18,y-18 , 36,36 , False
	    Color 255,255,0
	    Line x,y , x+sh\s*10,y+sh\t*10
	EndIf

	;check for docking (NOTE: has to come last because of ss pointer overwrite!)
	If KeyDown(pl\key_up)+KeyDown(pl\key_down)=0 Then
		For sh2.ship=Each ship
			ss.ship_stats=sh2\ship
			If sh2\freq=pl\freq And ss\carrier=True And RectsOverlap(sh2\x-sh\x,sh2\y-sh\y,1,1,-18,-18,36,36) Then
				If VectorDistance(sh\s-sh2\s,sh\t-sh2\t)<2 Then
					sh\docked=sh2
					sh\dead=True
					ResetTimer(sh\docked_t,reloaddelay)
				EndIf
			EndIf
		Next
	EndIf
EndIf

If pl\screenshake<>0 Then
	pl\x#=sh\x#+Rand(-3,3)
	pl\y#=sh\y#+Rand(-3,3)
	If FL\CurrentTicks-pl\screenshake>500 Then pl\screenshake=0
Else
	pl\x#=sh\x#		;update player position needed to offset other images, probably should make the player's ship type global instead?
	pl\y#=sh\y#
EndIf

Return

;----------------------------------------------------
;----------------------------------------------------
.update_exhaust
For ex.exhaust=Each exhaust
	DrawImage exhaust,ex\x-pl\x#,ex\y-pl\y#,ex\frame#
	ex\frame#=ex\frame#+1.8*FL\SpeedFactor#
	ex\x=ex\x-ex\s#*FL\SpeedFactor
	ex\y=ex\y+ex\t#*FL\SpeedFactor
	If ex\frame#>18 Then Delete ex
Next
Return

;----------------------------------------------------
;----------------------------------------------------
.update_npc
For np.npc=Each npc
	sh.ship=np\ship
	ss.ship_stats=sh\ship
	If sh\dead=True Then
		Gosub remove_ship
		If SuperArcade=False Then Goto stop_npc
	EndIf
	wg.weap_gun_stats=ss\weap_gun
	wb.weap_bmb_stats=ss\weap_bmb

	fm.formation=sh\formation
	;Case state_seek
	;	nofire=True
	;	np\target_angle=vectorangle(fm\targetx-sh\x,fm\targety-sh\y)
;
	;    dist = VectorDistance( sh\x-fm\targetx,sh\y-fm\targety )
	;    If dist >= 10
	;        sh\thrust = sh\thrust + 1 * FL\SpeedFactor
	;    Else
	;        sh\thrust = sh\thrust - 1 * FL\SpeedFactor
	;    EndIf
	;	sh\thrust = CapFloat( sh\thrust , -maxthrust ,maxthrust )

	;    If FL\CurrentTicks-np\targetcheck>=4500
	;		np\targetcheck=FL\CurrentTicks+Rand(1000)
	;		For np2.npc=Each npc
	;			sh2.ship=np2\ship
	;			If sh2\freq<>sh\freq And RectsOverlap(sh2\x#,sh2\y#,36,36,sh\x#-radarrange/2,sh\y#-radarrange/2,radarrange,radarrange)
	;				fm\state=state_hunt
	;			EndIf
	;		Next
	;	EndIf
	;Case state_hunt
	;	If FL\CurrentTicks-np\targetcheck>=4500 Or np\target=Null
	;		np\targetcheck=FL\CurrentTicks+Rand(1000)
	;		np\target=GetNearestTarget(sh.ship)
	;	EndIf
	;	tg.ship=np\target

	;	nofire = Not HostileEnemy

	;    If FL\CurrentTicks-np\interceptcheck>=100
	;        np\interceptcheck=FL\CurrentTicks+Rand(100)	;prevent each npc from updating at the same time
	        ;Local target_angle# = InterceptAngle( np\x#,np\y# , np\s#,np\t# , pl\x#,pl\y# , pl\s#,pl\t# , wb\speed + VectorDistance(np\s,np\t) )
	        ; predict angle of intercept using relative velocities
	        ; - use average speed between bomb and bullet
	        ; - fix speed/time by delta-time 'equivalent'
	;		Local AvgWepSpeed#=0
	;		If wg<>Null Then AvgWepSpeed#=wg\speed#
	;		If wb<>Null Then AvgWepSpeed#=AvgWepSpeed#+wb\speed#
	
			;acquire target angle
	;		np\target_angle = InterceptAngle( sh\x,sh\y , sh\s,sh\t , tg\x,tg\y , tg\s,tg\t , ( AvgWepSpeed# ) / 2 / FL\SpeedFactor )
	;		If np\target_angle = unreachable
	;			; use direct
	;			np\target_angle = VectorAngle( tg\x-sh\x,tg\y-sh\y )
	;		EndIf
	;    End If

	;    dist = VectorDistance( sh\x-tg\x,sh\y-tg\y )
	;    If dist >= ss\standoff
	;        sh\thrust = sh\thrust + 1 * FL\SpeedFactor
	;    Else
	;        sh\thrust = sh\thrust - 1 * FL\SpeedFactor
	;    EndIf
	;	sh\thrust = CapFloat( sh\thrust , -maxthrust ,maxthrust )
	;End Select

	If sh\target<>Null Then
		tg.ship=sh\target
	    If FL\CurrentTicks-np\interceptcheck>=100
	        np\interceptcheck=FL\CurrentTicks+100
	        ;Local target_angle# = InterceptAngle( np\x#,np\y# , np\s#,np\t# , pl\x#,pl\y# , pl\s#,pl\t# , wb\speed + VectorDistance(np\s,np\t) )
	        ; predict angle of intercept using relative velocities
	        ; - use average speed between bomb and bullet
	        ; - fix speed/time by delta-time 'equivalent'
			Local AvgWepSpeed#=0
			If wg<>Null Then AvgWepSpeed#=wg\speed#
			If wb<>Null Then AvgWepSpeed#=AvgWepSpeed#+wb\speed#/(1+1*AvgWepSpeed#<>0)
	
			;acquire target angle
			sh\target_angle = InterceptAngle( sh\x,sh\y , sh\s,sh\t , tg\x,tg\y , tg\s,tg\t , ( AvgWepSpeed# ) / FL\SpeedFactor )
			If sh\target_angle = unreachable
				; use direct
				sh\target_angle = VectorAngle( tg\x-sh\x,tg\y-sh\y )
			EndIf

			;check distance
			np\dist = VectorDistance( sh\x-tg\x,sh\y-tg\y )
	    End If
	ElseIf fm\state=state_attack
		sh\target=GetNearestTarget(sh)
		;If sh\target=Null Then
		;	fm\state=state_seek
		;	hr(fm\freq)\available[fm\role]=hr(fm\freq)\available[fm\role]+1
		;EndIf
	Else
		np\dist = VectorDistance( sh\x-fm\targetx,sh\y-fm\targety )
	EndIf

	If np\dist>ss\standoff Or fm\nodistcheck=True Then
		sh\thrust = sh\thrust + 1 * FL\SpeedFactor
	Else
	    sh\thrust = sh\thrust - 1 * FL\SpeedFactor
	EndIf
	sh\thrust = CapFloat( sh\thrust , -maxthrust ,maxthrust )

	If Not InstantTurnNPC
        ; turn to match predicted player-hit-angle
        ; - use 'angle difference' to prevent npc
        ;   from turning a near-full 360 sometimes
        turn_dir = Sgn( AngleDifference( sh\target_angle , sh\angle ) )
        sh\angle# = sh\angle# + turn_dir * ss\turnspeed# * FL\SpeedFactor
    Else
        ; instantly match predicted player-hit-angle
        sh\angle = sh\target_angle
    End If
    sh\angle = RangeFloat( sh\angle , 359 )

	speedx# = ss\accel * sh\thrust * table_sin( sh\angle ) / maxthrust
	speedy# = ss\accel * sh\thrust * table_cos( sh\angle ) / maxthrust
    
	; speedX and speedY
	sh\s = sh\s + speedx#
	sh\t = sh\t - speedy#
    
	; circular speed limiter
	ship_speed# = VectorDistance( sh\s,sh\t )
	If ship_speed > ss\topspeed
	    ship_speed = ss\topspeed
	    ship_heading# = VectorAngle( sh\s,sh\t )
	    sh\s = VectorX( ship_speed,ship_heading )
	    sh\t = VectorY( ship_speed,ship_heading )
	End If

	sh\x#=sh\x#+sh\s#*FL\SpeedFactor#						;apply velocity to player position
	sh\y#=sh\y#+sh\t#*FL\SpeedFactor#
    
	;firing logic
	If fm\nofire=False And sh\target<>Null Then
        If ss\weap_bmb<>Null
			If TimerState(sh\reload_bmb)=0 And Abs( AngleDifference(sh\target_angle,sh\angle) ) < .1 Then
				Gosub CreateBomb
				If sh\bombs=0 Then
					bombcount=0
					For a=0 To maxformshp
						If fm\ship[a]<>Null Then
							sh2.ship=fm\ship[a]
							bombcount=bombcount+sh\bombs
						EndIf
					Next
					If bombcount=0 Then
						If fm\target<>Null Then
							fm2.formation=fm\target
							Select fm2\role						;check target role
							Case role_capship
								fm\state=state_return
							Case role_fighter,role_bomber
								If ss\weap_gun=Null Then		;formation's ship type has no guns, and no bombs
									fm\state=state_return
								EndIf
							End Select
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
		If ss\weap_gun<>Null
			If TimerState(sh\reload_gun)=0 And Abs( AngleDifference(sh\target_angle,sh\angle) ) < 2 Then
				Gosub CreateBullet
			EndIf
		EndIf
	EndIf

	If ss\weap_gun<>Null
		If sh\ammo=0 Then
			If TimerDone(sh\reload_gun) Then												;reload guns
				PauseTimer(sh\reload_gun)
				sh\ammo=wg\ammo
			EndIf
		ElseIf TimerDone(sh\reload_gun) Then
			PauseTimer(sh\reload_gun)
		EndIf
	EndIf

	If ss\weap_bmb<>Null Then
		If sh\bombs<>0 And TimerDone(sh\reload_bmb) Then									;reload bombs
			PauseTimer(sh\reload_bmb)
		EndIf
	EndIf

	If TimerDone(sh\recharge_t) Then														;recharge shields
		sh\shield=sh\shield+ss\recharge
		If sh\shield>=ss\shield Then
			sh\shield=ss\shield
			PauseTimer(sh\recharge_t)
		Else
			ResetTimer(sh\Recharge_t)
		EndIf
	EndIf

	If ss\capship=True Then																;capital ship
		If ImageRectOverlap(ss\img,screenxmid+sh\x#-pl\x#,screenymid+sh\y#-pl\y#,0,0,screenx,screeny) Or DebugTargets Then
			DrawImage ss\img,screenxmid+sh\x#-pl\x#,screenymid+sh\y#-pl\y#,Floor#(sh\angle#/9)
			If DebugTargets  ; backquote (debug)
				x=screenxmid+sh\x-pl\x
				y=screenymid+sh\y-pl\y
				; target (player)
				;Color 128,0,0
		        ;Line x,y , x+(pl\x-sh\x),y+(pl\y-sh\y)
		        ; perfect aim (target angle + target distance)
		        Color 255,0,0
		        Line x,y , x+VectorX(np\dist,sh\target_angle),y+VectorY(np\dist,sh\angle)
		        ; ship angle
		        Color 255,128,0
		        Line x,y , x+VectorX(36,sh\angle),y+VectorY(36,sh\angle)
		        ; ship heading
		        Color 255,255,0
		        Line x,y , x+sh\s*10,y+sh\t*10
		    EndIf
		EndIf
	Else																				;fighter ship
		;calculate 'roll'
		aV#=ATan2(sh\s#,-sh\t#)
		difference=AngleDifference(sh\angle#,aV#)
		sh\roll#=Sin(difference)*5*sh\thrust/maxthrust

		;create thruster flames
		If sh\thrust<>0 And TimerDone(sh\exhaust_t) Then Gosub CreateExhaust

		;only draw if on screen
		If ImageRectOverlap(ss\img,screenxmid+sh\x#-pl\x#,screenymid+sh\y#-pl\y#,0,0,screenx,screeny) Or DebugTargets
			DrawImage ss\img,screenxmid+sh\x#-pl\x#,screenymid+sh\y#-pl\y#,200+Floor#(sh\angle#/9)+40*Int(sh\roll#)
			For a=1 To Len(designation(sh\freq,fm\designation))+2
				DrawImage font(1),screenxmid+sh\x#-pl\x#+10+font_x(1)*a,screenymid+sh\y#-pl\y#+18,Asc(Mid(designation(sh\freq,fm\designation)+" "+Str(sh\designation),a,1))+160+192*(sh\freq=pl\freq)
			Next
			If DebugTargets  ; backquote (debug)
				x=screenxmid+sh\x-pl\x
				y=screenymid+sh\y-pl\y
				; target (player)
				;Color 128,0,0
		        ;Line x,y , x+(pl\x-sh\x),y+(pl\y-sh\y)
		        ; perfect aim (target angle + target distance)
		        Color 255,0,0
		        Line x,y , x+VectorX(np\dist,sh\target_angle),y+VectorY(np\dist,sh\angle)
		        ; ship angle
		        Color 255,128,0
		        Line x,y , x+VectorX(36,sh\angle),y+VectorY(36,sh\angle)
		        ; ship radius
		        Color 0,255,255
		        Oval x-18,y-18 , 36,36 , False
		        ; ship heading
		        Color 255,255,0
		        Line x,y , x+sh\s*10,y+sh\t*10
		    EndIf
		EndIf
	EndIf
	.stop_npc
Next
Return

;----------------------------------------------------
;----------------------------------------------------
.update_turret
For tu.turret=Each turret
	sh.ship=tu\ship
	If tu\ship=Null Then	;delete turret if ship is destroyed
		DeleteTimer(tu\reload_gun)
		Delete tu
		Goto stop_turret
	EndIf
	ss.ship_stats=sh\ship
	ts.turret_stats=ss\turret[tu\id]
	wg.weap_gun_stats=ts\weap_gun

	;get proper turret 'position'
	xmod#=sh\x+ss\turret_pos[tu\id]*table_sin(ss\turret_angle[tu\id]+Floor(sh\angle))
	ymod#=sh\y-ss\turret_pos[tu\id]*table_cos(ss\turret_angle[tu\id]+Floor(sh\angle))

	If sh=pl\ship And tu\id=pl\sel_turret Then
		tu\target_angle=VectorAngle(xmod-screenxmid+MouseX()-pl\x,ymod-screenymid+MouseY()-pl\y)

		If MouseDown(1) And TimerState(tu\reload_gun)=0 Then
			Gosub CreateBullet_turret
		EndIf

		DrawImage turretO,screenxmid+xmod-pl\x#,screenymid+ymod-pl\y#,Floor#(tu\target_angle/9)
	Else
		If FL\CurrentTicks-tu\targetcheck>=500
			tu\targetcheck=FL\CurrentTicks+1000
			tu\target=GetNearestTarget(sh)
		EndIf

		nofire=Not HostileEnemy

		If tu\target<>Null Then
			tg.ship=tu\target
		    If FL\CurrentTicks-tu\interceptcheck>=100
		        tu\interceptcheck=FL\CurrentTicks+100	;prevent each turret from updating at the same time

				;acquire target angle
				tu\target_angle = InterceptAngle( xmod,ymod , sh\s,sh\t , tg\x,tg\y , tg\s,tg\t ,  wg\speed# / FL\SpeedFactor )
				If tu\target_angle = unreachable
					; use direct
					tu\target_angle = VectorAngle( tg\x-xmod,tg\y-ymod )
				EndIf
		    End If
		EndIf

		;firing logic
		If nofire=False And tu\target<>Null And TimerState(tu\reload_gun)=0 And Abs( AngleDifference(tu\target_angle,tu\angle) ) < 2 Then
			Gosub CreateBullet_turret
		EndIf
	EndIf
	
	If Not InstantTurnNPC
        ; turn to match predicted player-hit-angle
        ; - use 'angle difference' to prevent npc
        ;   from turning a near-full 360 sometimes
        turn_dir = Sgn( AngleDifference( tu\target_angle , tu\angle ) )
        tu\angle# = tu\angle# + turn_dir * ts\turnspeed# * FL\SpeedFactor
    Else
        ; instantly match predicted player-hit-angle
        tu\angle = tu\target_angle
    End If
    tu\angle = RangeFloat( tu\angle , 359 )
    
	If tu\ammo=0
		If TimerDone(tu\reload_gun) Then												;reload guns
			PauseTimer(tu\reload_gun)
			tu\ammo=wg\ammo
		EndIf
	ElseIf TimerState(tu\reload_gun)=1 Then												;recharge guns
		If TimerDone(tu\reload_gun) Then PauseTimer(tu\reload_gun)
	EndIf

	If ImageRectOverlap(turret2,screenxmid+xmod-pl\x#,screenymid+ymod-pl\y#,0,0,screenx,screeny) Then
		DrawImage ts\img,screenxmid+xmod-pl\x#,screenymid+ymod-pl\y#,Floor#(tu\angle#/9)
	EndIf
	.stop_turret
Next
Return

;----------------------------------------------------
;----------------------------------------------------
.update_particles
For pa.particle=Each particle
	Color colour(pa\col_x,pa\col_y,0),colour(pa\col_x,pa\col_y,1),colour(pa\col_x,pa\col_y,2)
	Rect screenxmid+pa\x#-pl\x#,screenymid+pa\y#-pl\y#,1,1
	pa\col_x=pa\col_x+1*FL\SpeedFactor
	If pa\col_x>13 Then Delete pa					;13 pixels limit for particles color
Next
Return

;----------------------------------------------------
;----------------------------------------------------
.update_bullets
For bu.bullet=Each bullet
	wg.weap_gun_stats=bu\gun
	bu\x#=bu\x#+bu\s#*FL\SpeedFactor#
	bu\y#=bu\y#+bu\t#*FL\SpeedFactor#
    
	For sh.ship=Each ship
		If sh\freq<>bu\freq And sh\dead=False Then
			ss.ship_stats=sh\ship
			If ss\capship=True Then
				If ImagesCollide(bullet1,bu\x#,bu\y#,bu\frame#,ss\img,sh\x#,sh\y#,Floor#(sh\angle#/9)) Then
					Gosub ShipTakeBulletDamage
					DeleteTimer(bu\life_t)
					Delete bu
					Goto stop_bullet
				EndIf
			ElseIf VectorDistance(bu\x-sh\x,bu\y-sh\y)<=16;ImagesCollide(bullet1,bu\x#,bu\y#,bu\frame#,ss\img,sh\x#,sh\y#,200+Floor#(sh\angle#/9)+40*Int(sh\roll#))
				Gosub ShipTakeBulletDamage
				DeleteTimer(bu\life_t)
				Delete bu
				Goto stop_bullet
			EndIf
		EndIf
	Next

	If ImageRectOverlap(bullet1,screenxmid+bu\x#-pl\x#,screenymid+bu\y#-pl\y#,0,0,screenx,screeny)	;only draw if on screen
		DrawImage bullet1,screenxmid+bu\x#-pl\x#,screenymid+bu\y#-pl\y#,bu\frame#
		If FL\CurrentTicks>bu\particle_t+particledelay	;release particle trail
			pa.particle=New particle
	            pa\x#=bu\x#
	            pa\y#=bu\y#
	            pa\col_x=0
	            pa\col_y=wg\trail
			bu\particle_t=FL\CurrentTicks
		EndIf
		bu\frame#=bu\frame#+.1*FL\SpeedFactor#			;advance bullet frame
		If bu\frame#>bu\frame_end Then bu\frame#=bu\frame_end-3
	EndIf
	If TimerDone(bu\life_t) Then
		DeleteTimer(bu\life_t)
		Delete bu
	EndIf
	.stop_bullet
Next
Return

.update_trails
For tr.trail=Each trail
	DrawImage trail,screenxmid+tr\x#-pl\x#,screenymid+tr\y#-pl\y#,tr\frame#
	tr\frame#=tr\frame+1*FL\SpeedFactor#
	If tr\frame#>tr\frame_end Then Delete tr
Next
Return

;----------------------------------------------------
;----------------------------------------------------
.update_bombs
For bm.bomb=Each bomb
	wb.weap_bmb_stats=bm\bmb
	bm\x#=bm\x#+bm\s#*FL\SpeedFactor#
	bm\y#=bm\y#+bm\t#*FL\SpeedFactor#

	;check if proximity trigger is active
	If bm\trigger<>Null Then
		If TimerDone(bm\trigger_t) Then
			For sh2.ship=Each ship
				If sh2\dead=False And VectorDistance(bm\x-sh2\x,bm\y-sh2\y)<=wb\radius Then Gosub ShipTakeProxyDamage
			Next
			xp.explosion=New explosion					;bomb explosion
				xp\img=explode2
				xp\x#=screenxmid+bm\x#
				xp\y#=screenymid+bm\y#
				xp\frame_end=43
			DeleteTimer(bm\trigger_t)
			DeleteTimer(bm\life_t)
			Delete bm
			Goto stop_bomb
		Else
			sh.ship=bm\trigger
			dist=VectorDistance(bm\x#-sh\x#,bm\y#-sh\y#)
			If dist>bm\trigger_lastdist Then
				ElapseTimer(bm\trigger_t)
			Else
				bm\trigger_lastdist=dist
			EndIf
		EndIf
	EndIf

    For sh.ship=Each ship
        If bm\freq<>sh\freq And sh\dead=False Then
			ss.ship_stats=sh\ship
			If ss\capship=True Then
				If ImagesCollide(bombs,bm\x#,bm\y#,bm\frame#,ss\img,sh\x#,sh\y#,Floor#(sh\angle#/9)) Then
					For sh2.ship=Each ship
						If sh<>sh2 And sh2\dead=False And RectsOverlap(bm\x-wb\radius,bm\y-wb\radius,wb\radius*2,wb\radius*2,sh2\x,sh2\y,36,36) Then Gosub ShipTakeProxyDamage
					Next
					Gosub ShipTakeBombDamage
					If bm\trigger<>Null Then DeleteTimer(bm\trigger_t)
					DeleteTimer(bm\life_t)
					Delete bm
					Goto stop_bomb
				EndIf
			ElseIf VectorDistance(bm\x-sh\x,bm\y-sh\y)<=16 Then
				For sh2.ship=Each ship
					If sh<>sh2 And sh2\dead=False And RectsOverlap(bm\x-wb\radius,bm\y-wb\radius,wb\radius*2,wb\radius*2,sh2\x,sh2\y,36,36) Then Gosub ShipTakeProxyDamage
				Next
				Gosub ShipTakeBombDamage
				If bm\trigger<>Null Then DeleteTimer(bm\trigger_t)
				DeleteTimer(bm\life_t)
				Delete bm
				Goto stop_bomb
			ElseIf bm\trigger=Null And VectorDistance(bm\x#-sh\x#,bm\y#-sh\y#)<wb\proxy
				bm\trigger=sh
				bm\trigger_t=NewTimer(wb\timer)
			EndIf
		EndIf
    Next

	If ImageRectOverlap(bombs,screenxmid+bm\x#-pl\x#,screenymid+bm\y#-pl\y#,0,0,screenx,screeny)		;only draw if on screen
		DrawImage bombs,screenxmid+bm\x#-pl\x#,screenymid+bm\y#-pl\y#,bm\frame#
		If FL\CurrentTicks>bm\trail_t+traildelay
			tr.trail=New trail
	            tr\x#=bm\x#
	            tr\y#=bm\y#
	            tr\frame#=wb\trail
	            tr\frame_end=wb\trail+7
			bm\trail_t=FL\CurrentTicks
		EndIf
		bm\frame#=bm\frame#+.5*FL\SpeedFactor#
		If bm\frame#>bm\frame_end Then bm\frame#=bm\frame_end-9
	EndIf
	If TimerDone(bm\life_t) Then
		If bm\trigger<>Null Then DeleteTimer(bm\trigger_t)
		DeleteTimer(bm\life_t)
		Delete bm
	EndIf
	.stop_bomb
Next
Return

;----------------------------------------------------
;----------------------------------------------------
.update_debris_m										;moving junk
For dm.debris_m=Each debris_m
	If ImageRectOverlap(dm\img,dm\x#-pl\x#,dm\y#-pl\y#,0,0,screenx,screeny) Then
		DrawImage dm\img,dm\x#-pl\x#,dm\y#-pl\y#,dm\frame#
		dm\frame#=dm\frame#+((Abs(dm\s#)+Abs(dm\t#))/8)*FL\SpeedFactor#
		If dm\frame#>dm\frame_end Then dm\frame#=dm\frame_end-9
	EndIf
	dm\x#=dm\x#+dm\s#*FL\SpeedFactor#
	dm\y#=dm\y#-dm\t#*FL\SpeedFactor#
	dm\s#=dm\s#-Sgn(dm\s#)/150
	dm\t#=dm\t#-Sgn(dm\t#)/150
	If Abs(dm\s#+dm\t#)<0.1
		ds.debris_s=New debris_s
        ds\img=dm\img
        ds\x#=dm\x#
        ds\y#=dm\y#
        ds\frame#=dm\frame#
        ds\frame_end=dm\frame_end
		Delete dm
	EndIf
Next
Return

;----------------------------------------------------
;----------------------------------------------------
.update_debris_s										;still junk
For ds.debris_s=Each debris_s
	If ImageRectOverlap(ds\img,ds\x#-pl\x#,ds\y#-pl\y#,0,0,screenx,screeny) Then
		DrawImage ds\img,ds\x#-pl\x#,ds\y#-pl\y#,ds\frame#
		ds\frame#=ds\frame#+.02*FL\SpeedFactor#
		If ds\frame#>ds\frame_end Then ds\frame#=ds\frame_end-9
	EndIf
Next
Return

;----------------------------------------------------
;----------------------------------------------------
.update_explosion
For xp.explosion=Each explosion
	DrawImage xp\img,xp\x#-pl\x#,xp\y#-pl\y#,xp\frame#
	xp\frame#=xp\frame#+.5*FL\SpeedFactor#
	If xp\frame#>xp\frame_end Then Delete xp
Next
Return

;----------------------------------------------------
;----------------------------------------------------
.update_UI
;clock
clock$=Right$("00"+((FL\CurrentTicks/(3600000)) Mod 24),2)+":"+Right$("00"+((FL\CurrentTicks/(60000)) Mod 60),2)
drawtext(clock$,screenx-radarsize-16,screeny-radarsize-10-font_y(2),2,font_yellow)

;draw radar
xmod=screenx-radarsize-8
ymod=screeny-radarsize-8
;border
Color colour(currentcol,16,0),colour(currentcol,16,1),colour(currentcol,16,2)	;radar background
Rect screenx-radarsize-8,screeny-radarsize-8,radarsize,radarsize,True
Color colour(currentcol,1,0),colour(currentcol,1,1),colour(currentcol,1,2)		;radar border1
Rect screenx-radarsize-9,screeny-radarsize-9,radarsize+2,radarsize+2,False
Color colour(currentcol,2,0),colour(currentcol,2,1),colour(currentcol,2,2)		;radar border2
Rect screenx-radarsize-10,screeny-radarsize-10,radarsize+4,radarsize+4,False
Color colour(currentcol,3,0),colour(currentcol,3,1),colour(currentcol,3,2)		;radar border3
Rect screenx-radarsize-10,screeny-radarsize-11,radarsize+4,1,False
Rect screenx-radarsize-10,screeny-6,radarsize+4,1,False
Rect screenx-radarsize-11,screeny-radarsize-10,1,radarsize+4,False
Rect screenx-6,screeny-radarsize-10,1,radarsize+4,False
;blips
Viewport screenx-radarsize-8,screeny-radarsize-8,radarsize,radarsize
For np.npc=Each npc
	sh.ship=np\ship
	If RectsOverlap(sh\x#,sh\y#,36,36,pl\x#-radarrange/2,pl\y#-radarrange/2,radarrange,radarrange)
		col_y=34-5*(pl\freq=sh\freq)
		Color colour(currentcol,col_y,0),colour(currentcol,col_y,1),colour(currentcol,col_y,2)
		Rect xmod+radarsize/2+(sh\x#-pl\x#)/(radarrange/radarsize),ymod+radarsize/2+(sh\y#-pl\y#)/(radarrange/radarsize),2,2,True
	EndIf
Next
Viewport 0,0,screenx,screeny

sh.ship=pl\ship
ss.ship_stats=sh\ship
wg.weap_gun_stats=ss\weap_gun
wb.weap_bmb_stats=ss\weap_bmb

Color colour(currentcol,28,0),colour(currentcol,28,1),colour(currentcol,28,2)	;player blip
Rect xmod+radarsize/2,ymod+radarsize/2,2,2,True

;stat display
DrawImage disp,screenx-84,5
For char=Len(sh\shield) To 1 Step -1					;remaining shield
	img=Asc(Mid$(sh\shield,char,1))
	DrawImage engyfont,screenx-30-Len(sh\shield)*16+char*16,0,img-48
Next
For char=Len(sh\hp) To 1 Step -1						;remaining hp
	img=Asc(Mid$(sh\hp,char,1))
	DrawImage ledfont,screenx-19-Len(sh\hp)*7+char*7,33,img-48
Next
killer$=Str$(CapIntMax(pl\wins,99))
For char=Len(killer) To 1 Step -1						;kills
	img=Asc(Mid$(killer,char,1))
	DrawImage ledfont,screenx-19-Len(killer)*7+char*7,45,img-48
Next
bummer$=Str$(CapIntMax(pl\loss,99))
For char=Len(bummer) To 1 Step -1						;deaths
	img=Asc(Mid$(bummer,char,1))
	DrawImage ledfont,screenx-40-Len(bummer)*7+char*7,45,img-48
Next

;healthbar (=ammo meter bar) display
Color colour(0,4,0),colour(0,4,1),colour(0,4,2)			;token strip
Rect screenxmid+27,9,screenx/6,2,False
Rect screenxmid-screenx/6+9,9,screenx/6,2,False
If ss\weap_gun<>Null Then
	pl\hlthbar_x=pl\hlthbar_x+.4*FL\SpeedFactor			;actual meter bar
	If pl\hlthbar_x>13 Then pl\hlthbar_x=0
	If sh\ammo=0 Then
		Color colour(pl\hlthbar_x,pl\hlthbar_y,0),colour(pl\hlthbar_x,pl\hlthbar_y,1),colour(pl\hlthbar_x,pl\hlthbar_y,2)
		Rect screenxmid+27,13,TimerDelta(sh\reload_gun)*(screenx/6),6,True
	Else
		Color colour(pl\hlthbar_x,pl\hlthbar_y,0),colour(pl\hlthbar_x,pl\hlthbar_y,1),colour(pl\hlthbar_x,pl\hlthbar_y,2)
		Rect screenxmid+27,13,(Float(sh\ammo)/wg\ammo)*(screenx/6),6,True
	EndIf
EndIf
;healthbar2 (=afterburner meter bar) display
Color colour(pl\hlthbar_x,4,0),colour(pl\hlthbar_x,4,1),colour(pl\hlthbar_x,4,2)
Rect screenxmid+9-(sh\fuel/ss\burnfuel)*(screenx/6),13,(sh\fuel/ss\burnfuel)*(screenx/6),6,True

DrawImage hlthbar,screenxmid-40,0,(sh\reload_gun=0)		;energy bar image

;weapon icons
If ss\weap_gun<>Null Then DrawBlock icons,screenx-26,screenymid-32,wg\icon		;gun
If ss\weap_bmb<>Null And sh\bombs<>0 Then										;bomb (+ammo)
	DrawBlock icons,screenx-26,screenymid-8,wb\icon
	DrawBlock icondoor,screenx-34,screenymid,CapIntMax(sh\bombs, 10)
	If TimerState(sh\reload_bmb)=1 Then
		DrawImage iconmask,screenx-26+iconxoffset,screenymid-8
	EndIf
EndIf

;draw chatlog
For cm.chatmessage=Each chatmessage
	drawtext(cm\content,5,screeny-(cm\id-gonemessages)*font_y(2),2,cm\col)
Next
Return

.update_music
;check if music is still playing
If BASS_ChannelIsActive(music)=BASS_ACTIVE_STOPPED Then
	Repeat		;if not, get a new random track

		;TODO, get track from current playlist only
		a=Rand(0,max_music)
	Until a<>currenttrack
	currenttrack=a
	music=BASS_MIDI_StreamCreateFile(0,battlemusdir+playlist$(index(currenttrack))+track$(currenttrack),0,0,0,0) ; we load a midi file
	If Not BASS_ChannelPlay (music,0) DebugLog "Midi file not ready! "
EndIf
Return

.next_music
; play a new song
BASS_ChannelStop music
currenttrack=Rand(0,max_music)
music = BASS_MIDI_StreamCreateFile(0,battlemusdir+playlist$(index(currenttrack))+track$(currenttrack),0,0,0,0)
If Not BASS_ChannelPlay (music,0) Then DebugLog "Midi file not ready! "
Return

.apply_interlace
; update and draw interlace overlay
If FL\CurrentTicks - interlace_lasttime >= interlace_interval
	interlace_lasttime = FL\CurrentTicks
		interlace_offset = Not interlace_offset
End If
DrawImage interlace_screen , 0,interlace_offset

; shadow interlace mirror
SetBuffer ImageBuffer( dupli_screen )
Cls
SetBuffer BackBuffer()
CopyRect 0,0 , screenx,screeny , 0,0 , BackBuffer(),ImageBuffer( dupli_screen )
;DrawImage dupli_screen , Rand(-1,1),1
DrawImage dupli_screen , 0,1
Return

;----------------------------------------------------
;----------------------------------------------------
.remove_ship
For a=0 To 8				;generate debris
	dm.debris_m=New debris_m
		dm\img=ss\junk
		dm\x#=screenxmid+sh\x#
		dm\y#=screenymid+sh\y#
		dm\s#=table_sin(Rand(44)*a)+(sh\s#)
		dm\t#=table_cos(Rand(44)*a)-(sh\t#)
		dm\frame#=10*a
		dm\frame_end=dm\frame#+9
Next
xp.explosion=New explosion	;kill explosion
	xp\img=explode1
	xp\x#=screenxmid+sh\x#
	xp\y#=screenymid+sh\y#
	xp\frame_end=7

If SuperArcade=True Then	;super arcade mode
	pl\loss=pl\loss+1*(sh\freq=pl\freq)
	pl\wins=pl\wins+1*(sh\freq<>pl\freq)

	;*TODO* ship should respawn docked to the freq carrier
	; some more variation (To discourage spawnkilling ^^)
	sh\x=Rand(-screenx/2,screenx/2)
	sh\y=Rand(-screenx/2,screenx/2)
	; random velocity (drifting away from spawn point)
	sh\s=Rnd(1,2)*(Rand(0,1)*2-1)
	sh\t=Rnd(1,2)*(Rand(0,1)*2-1)
	; random angle
	sh\angle=Rand(0,359)
	sh\shield=ss\shield
	sh\recharge_t=0
	sh\hp=ss\hp
	sh\dead=False
	sh\bombs=ss\bombs

	If pl\ship=sh Then pl\screenshake=0
Else							;dead = dead mode
	;update formation
	fm.formation=sh\formation
	If sh\freq=pl\freq Then CreateMessage(msg_die,sh,Null,Null)
	If sh=hr(fm\freq)\mother Then hr(fm\freq)\mother=Null
	deletefm=False
	If fm\leader=sh				;update formation leader
		If sh=Last ship				;ship is last ship?
			deletefm=True			;delete formation
		Else
			sh2.ship=After sh
			If sh2\formation<>fm	;next ship is not part of formation?
				deletefm=True		;delete formation
			Else
				fm\leader=sh2		;set new leader
			EndIf
		EndIf
	EndIf

	If pl\ship=sh Then			;remove player ship
		pl\screenshake=0			;reset screen shaker
		If deletefm=False And sh2<>Null Then		;we can safely use the next ship in the formation?
			pl\ship=sh2.ship
			For np.npc=Each npc						;remove the npc that is controlling our new ship
				If np\ship=sh2 Then
					Delete np
					Exit
				EndIf
			Next
		Else						;search for a new ship
			sh2=pl\ship
			Repeat
				If sh2=Last ship
					sh2.ship=First ship
				Else
					sh2.ship=After sh2
				EndIf
			Until sh2\freq=pl\freq
			For np.npc=Each npc
				If np\ship=sh2 Then
					Delete np
					Exit
				EndIf
			Next
			pl\ship=sh2
			If pl\ship=sh Then End	;game over man
		EndIf
	Else
		Delete np
	EndIf

	;update win-loss ratio
	pl\loss=pl\loss-1*(sh\freq=pl\freq)
	pl\wins=pl\wins-1*(sh\freq<>pl\freq)

	;If pl\wins=0 And hr(fm\freq)\mother<>Null Then	;mission accomplished
	;	createmessage(msg_winner,hr(fm\freq)\mother,Null,Null)
	;	For fm.formation=Each formation
	;		If fm\role<>role_capship Then
	;			fm\state=state_docking
	;			fm\target=hr(fm\freq)\mother\formation
	;		EndIf
	;	Next
	;EndIf

	;delete formation
	If deletefm=True Then
		;update heuristics
		hr(fm\freq)\formations[fm\role]=hr(fm\freq)\formations[fm\role]-1		;-1 formation
		Select fm\state
		Case state_seek															;formation was in available state?
			hr(fm\freq)\available[fm\role]=hr(fm\freq)\available[fm\role]-1
		End Select

		;sort out formation targeting
		If fm\istarget=True Then
			For fm2.formation=Each formation
				;NOTE: only checks target, but not mission. Might be a problem later (e.g. escort friendly formation, dock at friendly carrier)
				If fm2\target=fm Then
					fm2\state=state_regroup
					fm2\target=Null
				EndIf
			Next
		Else
			hr(Not fm\freq)\targets[fm\role]=hr(Not fm\freq)\targets[fm\role]-1	;formation was not targeted, reduce the available target counter
		EndIf
		If fm\target<>Null Then
			fm2.formation=GetNearestSupportFm(fm\target)
			If fm2<>Null Then
				fm2\target=fm\target
				hr(fm2\freq)\available[fm2\role]=hr(fm2\freq)\available[fm2\role]-1
			Else
				fm2.formation=fm\target
				fm2\istarget=False
				hr(fm\freq)\targets[fm2\role]=hr(fm\freq)\targets[fm2\role]+1
			EndIf
		EndIf
		set_heuristicsassignment(Not fm\freq,fm\role)
		Delete fm
	EndIf

	;remove timer objects
	If ss\weap_gun<>Null Then DeleteTimer(sh\reload_gun)
	If ss\weap_bmb<>Null Then DeleteTimer(sh\reload_bmb)
	DeleteTimer(sh\recharge_t)
	DeleteTimer(sh\reburn_t)
	DeleteTimer(sh\exhaust_t)

	Delete sh
EndIf
Return

; draw simple grid (optimized)
Function DrawGrid( x,y , w,h , ww,wh , colrow=17 )
    ; grid color = 17 (dark green low)
    ;              19 (dark green high)
	Color colour(currentcol#,colrow,0),colour(currentcol#,colrow,1),colour(currentcol#,colrow,2)
    
    Local px = x Mod w
    Repeat
        Rect px,0 , 1,wh
        px = px + w
    Until px >= ww
    
    Local py = y Mod h
    Repeat
        Rect 0,py , ww,1
        py = py + h
    Until py >= wh
    
End Function

; draw 2-colored grid
Function DrawGrid2( x,y , w#,h# , ww,wh , colrow1=17,colrow2=19 )
	; colrow1 = darker , colrow2 = ligher
	
	; cut each sector/section in 16 blocks
	w = w / 4
	h = h / 4
    
	Local count
	
    Local px# = x Mod w
    Local py# = y Mod h
	
    Repeat
		If count = 0
			Color colour(currentcol#,colrow2,0),colour(currentcol#,colrow2,1),colour(currentcol#,colrow2,2)
		Else
			Color colour(currentcol#,colrow1,0),colour(currentcol#,colrow1,1),colour(currentcol#,colrow1,2)
		End If
        Rect px,0 , 1,wh
        px = px + w
		If count = 3
			count = 0
		Else
			count = count + 1
		End If
    Until px >= ww
	
	px = x Mod w
	
    Repeat
		If count = 0
			Color colour(currentcol#,colrow2,0),colour(currentcol#,colrow2,1),colour(currentcol#,colrow2,2)
		Else
			Color colour(currentcol#,colrow1,0),colour(currentcol#,colrow1,1),colour(currentcol#,colrow1,2)
		End If
        Rect 0,py , ww,1
        py = py + h
		If count = 3
			count = 0
		Else
			count = count + 1
		End If
    Until py >= wh
    
	SetFont FontMedium
End Function

; draw 2-colored grid with (optional) coordinates
; - now working as it should ^^
Function DrawGrid3( x,y , w#,h# , ww,wh , scale#=1,offsetx=0,offsety=0 , coords=True,colrow1=17,colrow2=19,colrow3=23 )
	; scale/offsetx/offsety are for coords values only
	; colrow1 = darker (lines) , colrow2 = ligher (lines) , colrow3 = lightest (coords)
	SetFont FontSmall
	
	Local ox# = x
	Local oy# = y
	Local ow# = w
	Local oh# = h
	
	; cut each sector/section in 16 blocks
	w = ow / 4
	h = oh / 4
    
	Local count
	
    Local px# = ox Mod ow - ow
    Local py# = oy Mod oh - oh
	
	count = 0
    Repeat
		If count = 0
			Color colour(currentcol#,colrow2,0),colour(currentcol#,colrow2,1),colour(currentcol#,colrow2,2)
		Else
			Color colour(currentcol#,colrow1,0),colour(currentcol#,colrow1,1),colour(currentcol#,colrow1,2)
		End If
        Rect px,0 , 1,wh
		If count = 0
			Color colour(currentcol#,colrow3,0),colour(currentcol#,colrow3,1),colour(currentcol#,colrow3,2)
			;Color 255,255,255
			Text px+4,4 , Int ( (px+offsetx) / scale )
		End If
        px = px + w
		If count = 3
			count = 0
		Else
			count = count + 1
		End If
    Until px >= ww
	
	px = ox Mod ow - ow
	py = oy Mod oh - oh
	
	count = 0
    Repeat
		If count = 0
			Color colour(currentcol#,colrow2,0),colour(currentcol#,colrow2,1),colour(currentcol#,colrow2,2)
		Else
			Color colour(currentcol#,colrow1,0),colour(currentcol#,colrow1,1),colour(currentcol#,colrow1,2)
		End If
        Rect 0,py , ww,1
		If count = 0
			Color colour(currentcol#,colrow3,0),colour(currentcol#,colrow3,1),colour(currentcol#,colrow3,2)
			;Color 255,255,255
			Text 4,py+4 , Int ( (py+offsety) / scale )
		End If
        py = py + h
		If count = 3
			count = 0
		Else
			count = count + 1
		End If
    Until py >= wh
    
	SetFont FontMedium
End Function

; pad string with spaces, limited to max size
Function ps$( msg% , maxchars=4 , padchar$=" " )
    Local length = Len( msg )
    ; too big
    If length > maxchars
        ; keep only right part
        Return Right( msg , maxchars )
    ; too small
    ElseIf length < maxchars
        ; pad right with spaces
        Return msg + String( padchar , maxchars-length )
    End If
    ; perfect
    Return msg
End Function
;Function test_ps()
;    For i=0 To 10
;        n$ = Left( "abcdefghij" , i )
;        Print n+" -> ("+ps(n)+")"
;    Next
;    WaitKey
;    End
;End Function

;----------------------------------------------------
;----------------------------------------------------
.CreateBullet
If sh\multi=False Then
	If wg\sequenced=True Then							;sequenced firing
		bu.bullet=New bullet
		bu\gun=wg
		bu\frame#=wg\frame
		bu\frame_end=wg\frame+3

		bulletspawnangle#=sh\angle#+wg\angle_start[sh\barrel]
		bulletangle#=sh\angle#+wg\angle_travel[sh\barrel]
		;bulletspeed#=VectorDistance( sh\s#,sh\t# ) + wg\speed
		bulletspeed#=wg\speed
		
		bu\x#=VectorX(15,bulletspawnangle#)+sh\x#
		bu\y#=VectorY(15,bulletspawnangle#)+sh\y#
		bu\s#=VectorX(bulletspeed#,bulletangle#) + sh\s#
		bu\t#=VectorY(bulletspeed#,bulletangle#) + sh\t#
		;bu\x#=sh\x#+15*table_sinA(sh\angle#+wg\angle_start[sh\barrel]+table_sin(Floor(sh\angle#)))
		;bu\y#=sh\y#-15*table_cosA(sh\angle#+wg\angle_start[sh\barrel]+table_cos(Floor(sh\angle#)))
		;bu\s#=wg\speed*table_sinA(sh\angle#+wg\angle_travel[sh\barrel]+table_sin(Floor(sh\angle#)))+sh\s#
		;bu\t#=-wg\speed*table_cosA(sh\angle#+wg\angle_travel[sh\barrel]+table_cos(Floor(sh\angle#)))+sh\t#
		bu\life_t=NewTimer(wg\life)
		bu\freq=sh\freq
		bu\owner=sh
		sh\ammo=sh\ammo-1
		sh\barrel=sh\barrel+1
		If sh\barrel>wg\barrels Then sh\barrel=0
	Else
		For barrel=0 To wg\barrels-wg\multi				;fire all but multifire barrels
			bu.bullet=New bullet
			bu\gun=wg
			bu\frame#=wg\frame
			bu\frame_end=wg\frame+3

			bulletspawnangle#=sh\angle#+wg\angle_start[sh\barrel]
			bulletangle#=sh\angle#+wg\angle_travel[sh\barrel]
			;bulletspeed#=VectorDistance( sh\s#,sh\t# ) + wg\speed
			bulletspeed#=wg\speed
			
			bu\x#=VectorX(15,bulletspawnangle#)+sh\x#
			bu\y#=VectorY(15,bulletspawnangle#)+sh\y#
			bu\s#=VectorX(bulletspeed#,bulletangle#) + sh\s#
			bu\t#=VectorY(bulletspeed#,bulletangle#) + sh\t#

			bu\life_t=NewTimer(wg\life)
			bu\freq=sh\freq
			bu\owner=sh
			sh\ammo=sh\ammo-1
		Next
	EndIf
	ResetTimer(sh\reload_gun,wg\rof)
Else
	For barrel=0 To wg\barrels							;fire everything!
		bu.bullet=New bullet
		bu\gun=wg
		bu\frame#=wg\frame
		bu\frame_end=wg\frame+3

		bulletspawnangle#=sh\angle#+wg\angle_start[sh\barrel]
		bulletangle#=sh\angle#+wg\angle_travel[sh\barrel]
		;bulletspeed#=VectorDistance( sh\s#,sh\t# ) + wg\speed
		bulletspeed#=wg\speed

		bu\x#=VectorX(15,bulletspawnangle#)+sh\x#
		bu\y#=VectorY(15,bulletspawnangle#)+sh\y#
		bu\s#=VectorX(bulletspeed#,bulletangle#) + sh\s#
		bu\t#=VectorY(bulletspeed#,bulletangle#) + sh\t#

		bu\life_t=NewTimer(wg\life)
		bu\freq=sh\freq
		bu\owner=sh
		sh\ammo=sh\ammo-1
	Next
	ResetTimer(sh\reload_gun,wg\rof_multi)
EndIf
If sh\ammo=0 Then ResetTimer(sh\reload_gun,wg\reload)
Return

;----------------------------------------------------
;----------------------------------------------------
.CreateBullet_turret
If tu\multi=False Then
	If wg\sequenced=True Then							;sequenced firing
		bu.bullet=New bullet
		bu\gun=wg
		bu\frame#=wg\frame
		bu\frame_end=wg\frame+3
		bu\x#=xmod#+15*table_sin(wg\angle_start[sh\barrel]+Floor(tu\angle#))
		bu\y#=ymod#-15*table_cos(wg\angle_start[sh\barrel]+Floor(tu\angle#))
		bu\s#=wg\speed*table_sin(wg\angle_travel[sh\barrel]+Floor(tu\angle#))+sh\s#
		bu\t#=-wg\speed*table_cos(wg\angle_travel[sh\barrel]+Floor(tu\angle#))+sh\t#
		bu\life_t=NewTimer(wg\life)
		bu\freq=sh\freq
		tu\ammo=tu\ammo-1
		tu\barrel=tu\barrel+1
		If tu\barrel>wg\barrels Then tu\barrel=0
	Else
		For barrel=0 To wg\barrels-wg\multi				;fire all but multifire barrels
			bu.bullet=New bullet
			bu\gun=wg
			bu\frame#=wg\frame
			bu\frame_end=wg\frame+3
			bu\x#=xmod#+15*table_sin(wg\angle_start[barrel]+Floor(tu\angle#))
			bu\y#=ymod#-15*table_cos(wg\angle_start[barrel]+Floor(tu\angle#))
			bu\s#=wg\speed*table_sin(wg\angle_travel[barrel]+Floor(tu\angle#))+sh\s#
			bu\t#=-wg\speed*table_cos(wg\angle_travel[barrel]+Floor(tu\angle#))+sh\t#
			bu\life_t=NewTimer(wg\life)
			bu\freq=sh\freq
			tu\ammo=tu\ammo-1
		Next
	EndIf
	ResetTimer(tu\reload_gun,wg\rof)
Else
	For barrel=0 To wg\barrels							;fire everything!
		bu.bullet=New bullet
		bu\gun=wg
		bu\frame#=wg\frame
		bu\frame_end=wg\frame+3
		bu\x#=xmod#+15*table_sin(wg\angle_start[barrel]+Floor(tu\angle#))
		bu\y#=ymod#-15*table_cos(wg\angle_start[barrel]+Floor(tu\angle#))
		bu\s#=wg\speed*table_sin(wg\angle_travel[barrel]+Floor(tu\angle#))+sh\s#
		bu\t#=-wg\speed*table_cos(wg\angle_travel[barrel]+Floor(tu\angle#))+sh\t#
		bu\life_t=NewTimer(wg\life)
		bu\freq=sh\freq
		tu\ammo=tu\ammo-1
	Next
	ResetTimer(sh\reload_gun,wg\rof_multi)
EndIf
If tu\ammo=0 Then ResetTimer(tu\reload_gun,wg\reload)
Return

;----------------------------------------------------
;----------------------------------------------------
.CreateBomb
xp.explosion=New explosion							;bomb flash
    xp\img=bombflsh
	xp\x#=screenxmid+sh\x#+10+15*table_sin(Floor(sh\angle#))
    xp\y#=screenymid+sh\y#+10-15*table_cos(Floor(sh\angle#))
	xp\frame_end=5
bm.bomb=New bomb
    bm\bmb=wb
    bm\frame#=wb\frame
    bm\frame_end=wb\frame+9
    bm\x#=sh\x#+15*table_sin(Floor(sh\angle#))
    bm\y#=sh\y#-15*table_cos(Floor(sh\angle#))
    bm\s#=wb\speed*table_sin(Floor(sh\angle#))+sh\s#
    bm\t#=-wb\speed*table_cos(Floor(sh\angle#))+sh\t#
    bm\life_t=NewTimer(wb\life)
    bm\freq=sh\freq
	bm\owner=sh
sh\bombs=sh\bombs-1
ResumeTimer(sh\reload_bmb)
sh\s#=sh\s#-wb\recoil*table_sin(Floor(sh\angle#))	;recoil
sh\t#=sh\t#+wb\recoil*table_cos(Floor(sh\angle#))
Return

;----------------------------------------------------
;----------------------------------------------------
.CreateExhaust
calc1s#=table_sin(sh\angle#)
calc1c#=table_cos(sh\angle#)

ex.exhaust=New exhaust								;exhaust 1
	ex\x=screenxmid+sh\x+15*table_sin(162+Floor(sh\angle))
	ex\y=screenymid+sh\y-15*table_cos(162+Floor(sh\angle))
    ex\s#=sh\thrust/maxthrust * 8*calc1s#*FL\SpeedFactor - sh\s
    ex\t#=sh\thrust/maxthrust * 8*calc1c#*FL\SpeedFactor + sh\t

ex.exhaust=New exhaust								;exhaust 2
	ex\x=screenxmid+sh\x+15*table_sin(198+Floor(sh\angle))
	ex\y=screenymid+sh\y-15*table_cos(198+Floor(sh\angle))
	ex\s#=sh\thrust/maxthrust * 8*calc1s#*FL\SpeedFactor - sh\s
	ex\t#=sh\thrust/maxthrust * 8*calc1c#*FL\SpeedFactor + sh\t

ResetTimer(sh\exhaust_t)
Return

Function GetNearestTarget.ship(sh.ship,rangelimit=radarrange/2)
	besttarget.ship=Null
	For tg.ship=Each ship
		If sh\freq<>tg\freq And tg\dead=False Then
			dist=VectorDistance(sh\x#-tg\x#,sh\y#-tg\y#)
			If dist<rangelimit Then
				besttarget=tg
				rangelimit=dist
			EndIf
		EndIf
	Next
	Return besttarget
End Function

Function GetNearestTargetFm.formation(fm.formation,rangelimit=100000)
	besttarget.formation=Null
	For tg.formation=Each formation
		If tg\freq<>fm\freq And tg\detected[fm\freq]=True And (IsValidTarget(fm\role,tg\role)=True Or hr(fm\freq)\assignment[fm\role]=0) Then
			dist=VectorDistance(fm\x-tg\x,fm\y-tg\y)
			If dist<rangelimit Then
				besttarget=tg
				rangelimit=dist
			EndIf
		EndIf
	Next

	If besttarget<>Null Then
		fm\state=state_attack
		fm\nofire=Not HostileEnemy
		fm\target=besttarget
		;assign individual targets
		For a=0 To maxformshp
			If fm\ship[a]<>Null Then
				sh.ship=fm\ship[a]
				b=a
				;divide targets over entire formation (if possible)
				While besttarget\ship[b]=Null
					b=b+1
					If b>3 Then b=0
				Wend
				sh\target=besttarget\ship[b]
			EndIf
		Next
		If fm\freq=pl\freq Then CreateMessage(msg_attack,fm\leader,besttarget\leader,Null)
	EndIf
	Return besttarget
End Function

Function GetNearestSupportFm.formation(target.formation,rangelimit=100000)
	candidate.formation=Null
	For fm.formation=Each formation
		If fm\freq<>target\freq And fm\state=state_seek And IsValidTarget(fm\role,target\role)=True Then
			dist=VectorDistance(fm\x-target\x,fm\y-target\y)
			If dist<rangelimit Then
				candidate=fm
				rangelimit=dist
			EndIf
		EndIf
	Next

	If candidate<>Null Then
		candidate\state=state_attack
		candidate\nofire=Not HostileEnemy
		candidate\target=target
		;assign individual targets
		For a=0 To maxformshp
			If candidate\ship[a]<>Null Then
				sh.ship=candidate\ship[a]
				b=a
				;divide targets over entire formation (if possible)
				While target\ship[b]=Null
					b=b+1
					If b>3 Then b=0
				Wend
				sh\target=target\ship[b]
			EndIf
		Next
		If candidate\freq=pl\freq Then CreateMessage(msg_attack,candidate\leader,target\leader,Null)
	EndIf
	Return candidate
End Function

;----------------------------------------------------
;----------------------------------------------------
.ShipTakeBulletDamage
	sh\shield=sh\shield-wg\dmg			;shield damage
	If sh\shield<0 Then					;shield breached
		sh\hp=sh\hp+sh\shield			;hull damage
		sh\shield=0
		If sh\hp<=0 Then				;ship destroyed
			sh\dead=True
			sh\hp=0
			If bu\freq=pl\freq Then
				sh2.ship=bu\owner
				If sh2<>Null Then CreateMessage(msg_kill,bu\owner,sh,Null)
			EndIf
		Else							;ship not destroyed
			xp.explosion=New explosion	;hit explosion
				xp\img=explode0
				xp\x#=screenxmid+bu\x#
				xp\y#=screenymid+bu\y#
				xp\frame_end=6
			If TimerState(sh\recharge_t)=0 Then ResetTimer(sh\recharge_t)
		EndIf
	Else								;shield not breached
		xp.explosion=New explosion		;shield hit explosion
	   	    xp\img=explode0_s
			xp\x#=screenxmid+bu\x#
			xp\y#=screenymid+bu\y#
			xp\frame_end=6
		If TimerState(sh\recharge_t)=0 Then ResetTimer(sh\recharge_t)
	EndIf
Return

.ShipTakeBombDamage
	sh\shield=sh\shield-wb\dmg			;shield damage
	If sh\shield<0 Then					;shield breached
		sh\hp=sh\hp+sh\shield			;hull damage
		sh\shield=0
		If sh\hp<=0 Then				;ship destroyed
			sh\dead=True
			sh\hp=0
			If bm\freq=pl\freq Then
				sh2.ship=bm\owner
				If sh2<>Null Then CreateMessage(msg_kill,sh2,sh,Null)
			EndIf
		Else							;ship not destroyed
			xp.explosion=New explosion	;hit explosion
				xp\img=explode2
				xp\x#=screenxmid+bm\x#
				xp\y#=screenymid+bm\y#
				xp\frame_end=43
			If TimerState(sh\recharge_t)=0 Then ResetTimer(sh\recharge_t)
		EndIf
	Else								;shield not breached
		xp.explosion=New explosion		;shield hit explosion
	   	    xp\img=explode2
			xp\x#=screenxmid+bm\x#
			xp\y#=screenymid+bm\y#
			xp\frame_end=43
		If TimerState(sh\recharge_t)=0 Then ResetTimer(sh\recharge_t)
	EndIf
Return

.ShipTakeProxyDamage
dist=VectorDistance(bm\x#-sh2\x#,bm\y#-sh2\y#)
If dist<wb\radius Then
	dmg_dist=ScalePoint(dist,0,wb\radius,wb\dmg,0)
	sh2\shield=sh2\shield-dmg_dist		;shield damage
	If sh2\shield<0 Then				;shield breached
		sh2\hp=sh2\hp+sh2\shield		;hull damage
		sh2\shield=0
		If sh2\hp<=0 Then				;ship destroyed
			sh2\dead=True
			sh2\hp=0
			If bm\freq=pl\freq Then
				tg.ship=bm\owner
				If tg<>Null Then CreateMessage(msg_kill,bm\owner,sh2,Null)
			EndIf
			Return
		ElseIf TimerState(sh2\recharge_t)=0 Then
			ResetTimer(sh2\recharge_t)
		EndIf
	ElseIf TimerState(sh2\recharge_t)=0 Then
		ResetTimer(sh2\recharge_t)
	EndIf
	If sh2=pl\ship Then					;screen shaking
		pl\screenshake=FL\CurrentTicks
	EndIf
EndIf
Return

Function update_attackprofile(target.formation,spotter.formation)
	Local candidate.formation
	Local rangelimit=1000000
	For fm.formation=Each formation
		If fm\freq=spotter\freq And fm\state=state_seek And (IsValidTarget(fm\role,target\role)=True Or hr(fm\freq)\assignment[fm\role]=0) Then
			dist=VectorDistance(fm\x-target\x,fm\y-target\y)
			If dist<rangelimit Then
				candidate=fm
				rangelimit=dist
			EndIf
		EndIf
	Next
	If candidate=Null Then Return False
	candidate\state=state_attack
	candidate\nofire=Not HostileEnemy
	candidate\target=target
	;assign individual targets
	For a=0 To maxformshp
		If candidate\ship[a]<>Null Then
			sh.ship=candidate\ship[a]
			b=a
			;divide targets over entire formation (if possible)
			While target\ship[b]=Null
				b=b+1
				If b>3 Then b=0
			Wend
			sh\target=target\ship[b]
		EndIf
	Next

	;update heuristics
	;one less formation available to intercept
	hr(spotter\freq)\available[candidate\role]=hr(spotter\freq)\available[candidate\role]-1

	;set msg
	If spotter\freq=pl\freq Then
		If candidate=spotter Then
			CreateMessage(msg_detectattack,spotter\leader,target\leader,Null)
		Else
			candidate\msg_id=msg_detectre
			candidate\msg_timer=NewTimer(Rand(500,1500))
			candidate\msg_CLI=candidate\leader
			candidate\msg_CLE=target\leader
			candidate\msg_callback=spotter\leader
		EndIf
	EndIf
	Return True
End Function

Function set_heuristicsassignment(freq,role)
	;update # of formations/target formation type
	If hr(freq)\targets[role]<>0 Then
		Select role
		;fighter and bomber targets are divided over fighter formations on a first come first serve basis
		Case role_fighter
			;fighters vs fighters
			hr(freq)\assignment[role_fighter]=Ceil( Float(hr(freq)\available[role_fighter]) / hr(freq)\targets[role_fighter] )
		Case role_bomber
			;fighters vs bombers
			hr(freq)\assignment[role_bomber]=Ceil( Float(hr(freq)\available[role_fighter]) / hr(freq)\targets[role_bomber] )
		Case role_capship
			;bombers and capships vs capships
			hr(freq)\assignment[role_capship]=Ceil( Float(hr(freq)\available[role_bomber])+Float(hr(freq)\available[role_capship]) / hr(freq)\targets[role_capship])
		End Select
	EndIf
End Function

Function CreateMessage(msg,talk.ship,ref.ship,re.ship)
	;message log update
	chatmessages=chatmessages+1
	If chatmessages>chatsize_y Then
		Delete First chatmessage
		gonemessages=gonemessages+1
	EndIf
	cm.chatmessage=New chatmessage
	cm\id=chatmessages

	;get talking ship's name
	fm.formation=talk\formation
	If fm\role=role_capship Then
		cm\content=RSet(Left(shipname(fm\freq,fm\designation),maxcallsign),maxcallsign)
	Else
		cm\content=RSet(Left(designation(fm\freq,fm\designation)+" "+Str(talk\designation),maxcallsign),maxcallsign)
	EndIf

	Select msg
	Case msg_motivate
		;message at mission start
		cm\content=cm\content+"> "+chat_motivate(Rand(0,maxmotivate))
		cm\col=font_green
	Case msg_detect
		;new enemy spotted
		cm\content=cm\content+"> "+chat_spotted(Rand(0,maxspotted))
		cm\col=font_yellow
	Case msg_detectattack
		;new enemy spotted & attacked
		cm\content=cm\content+"> "+chat_spotted(Rand(0,maxspotted))+", "+chat_targetre(Rand(0,maxtarget))
		cm\col=font_yellow
	Case msg_attack
		;new target
		cm\content=cm\content+"> "+chat_target(Rand(0,maxtarget))
		cm\col=font_red
	Case msg_detectre
		;new target (reply)
		cm\content=cm\content+"> "+chat_confirm(Rand(0,maxconfirm))+", "+chat_targetre(Rand(0,maxtargetre))
		cm\col=font_red
	Case msg_done
		;formation regroups, no capital ships
		cm\content=cm\content+"> "+chat_done(Rand(0,maxdone))
		cm\col=font_blue
	Case msg_die
		Select fm\role
		Case role_capship
			cm\content=cm\content+"> "+chat_diecs(Rand(0,maxdie_cs))
		Default
			cm\content=cm\content+"> "+chat_diefm(Rand(0,maxdie_fm))
		End Select
		cm\col=font_blue
	Case msg_kill
		cm\content=cm\content+"> "+chat_kill(Rand(0,maxkill))
		cm\col=font_gray
	Case msg_winner
		cm\content=cm\content+"> "+chat_win(Rand(0,maxwinner))
		cm\col=font_green
	End Select

	;detect&replace keywords
	Select fm\role
	Case role_capship
		cm\content=Replace(cm\content,"%name_talk%",shipname(fm\freq,fm\designation))
	Default
		cm\content=Replace(cm\content,"%name_talk%",designation(fm\freq,fm\designation)+" "+Str(talk\designation))
	End Select
	If re<>Null Then
		fm.formation=re\formation
		Select fm\role
		Case role_capship
			cm\content=Replace(cm\content,"%name_re%",shipname(fm\freq,fm\designation))
		Default
			cm\content=Replace(cm\content,"%name_re%",designation(fm\freq,fm\designation)+" "+Str(re\designation))
		End Select
		cm\content=Replace(cm\content,"%role_re%",role(fm\role,Rand(0,1)))
	EndIf
	If ref<>Null Then
		fm.formation=ref\formation
		Select fm\role
		Case role_capship
			cm\content=Replace(cm\content,"%name_ref%","the "+shipname(fm\freq,fm\designation))
		Default
			cm\content=Replace(cm\content,"%name_ref%",designation(fm\freq,fm\designation)+" formation")
		End Select
		cm\content=Replace(cm\content,"%role_ref%",role(fm\role,Rand(0,1)))
	EndIf

	;line wrap
	While Len(cm\content)>chatsize_x
		For a=chatsize_x To 1 Step -1
			char$=Mid(cm\content,a,1)
			If char$=" " Then
				;break
				chatmessages=chatmessages+1
				cmnew.chatmessage=New chatmessage
				cmnew\id=chatmessages
				If chatmessages>chatsize_y Then
					Delete First chatmessage
					gonemessages=gonemessages+1
				EndIf
				;If cm=Null Then Return
				;Insert cmnew Before cm
				cmnew\content=Left$(cm\content,a-1)
				cmnew\col=cm\col
				cm\content=Right$(cm\content,Len(cm\content)-a+1)
				If cm<>cmnew Then cm\content=RSet(">",maxcallsign+1)+cm\content
				Exit
			EndIf
		Next
	Wend
End Function

Function IsValidTarget(role,targetrole)
	Select role
	Case role_fighter
		If targetrole<>role_capship Then Return True
	Case role_bomber
		If targetrole=role_capship Then Return True
	Case role_capship
		If targetrole=role_capship Then Return True
	End Select
End Function

;----------------------------------------------------
;----------------------------------------------------
.map_view
;TODO: working zoom
PauseAllTimers()
Gosub update_formations
sh.ship=pl\ship
fm.formation=sh\formation
mapselfm.formation=fm
mouseoverfm.formation=Null
mapx=fm\x
mapy=fm\y
mapz#=0.2
Const MouseMapScrollDistance = 16  ; num pixels from screen edge to start scrolling
Const MapScrollSpeed = 8
Const MapZoomSpeed# = 1.04
ShowPointer
Repeat
	;fps limiter
	FL\CurrentTicks=MilliSecs()
	FL\SpeedFactor=(FL\CurrentTicks - FL\FrameDelay)/(1000/FL\TargetFPS)
	If FL\SpeedFactor<=0 Then FL\SpeedFactor=0.00000000001    
	FL\FPS=FL\TargetFPS/FL\SpeedFactor    
	FL\FrameDelay=FL\CurrentTicks
	
	MilliSecs = FL\CurrentTicks

    currentcol#=currentcol#+4*FL\SpeedFactor											;advance current colour
	If currentcol#>127 Then currentcol#=0

	Viewport 0,0,mapxbar,screeny
	ClsColor colour(currentcol,16,0),colour(currentcol,16,1),colour(currentcol,16,2)
	Cls

	mapx=mapx+(KeyDown(pl\key_right)-KeyDown(pl\key_left))*MapScrollSpeed*FL\SpeedFactor / mapz
	mapy=mapy-(KeyDown(pl\key_up)-KeyDown(pl\key_down))*MapScrollSpeed*FL\SpeedFactor / mapz
    
    Local mx = MouseX()
    If mx < MouseMapScrollDistance Then
		mapx=mapx-MapScrollSpeed*FL\SpeedFactor / mapz
	ElseIf mx > screenx-1-MouseMapScrollDistance Then
		mapx=mapx+MapScrollSpeed*FL\SpeedFactor / mapz
	EndIf
    Local my = MouseY()
	If my < MouseMapScrollDistance Then
		mapy=mapy-MapScrollSpeed*FL\SpeedFactor / mapz
	ElseIf my > screeny-1-MouseMapScrollDistance Then
		mapy=mapy+MapScrollSpeed*FL\SpeedFactor / mapz
	EndIf
    Local mz = MouseZSpeed()  ; mouse scrollwheel
	; mouse zoom gets speed increase compared to keyboard
	Local mzi#  ; mouse zoom speed increase
	If mz <> 0
		mzi = 2
	Else
		mzi = 0.5
	End If
	If mz > 0 Or KeyDown(201)  ; scrollwheel up or page up
        mapz = mapz * MapZoomSpeed^Abs(mzi)
    End If
    If mz < 0 Or KeyDown(209)  ; scrollwheel down or page down
        mapz = mapz / MapZoomSpeed^Abs(mzi)
    End If
	If mapz > 1 Then mapz = 1
	If mapz < .1 Then mapz = .1
	;Text 15,400,mapz+"x"
	Local tbx = 24*1.5  ; text border
	Local tby = 24*1.0
    Color 0,192,64
	Text tbx,screeny-FontHeight()*2-tby,"X:"+mapx+"  Y:"+mapy
	show_mapz$ = Left( mapz , 4 )
	Text tbx,screeny-FontHeight()-tby,show_mapz$+"x"
    
	;DrawGrid mapxmid-(mapx)*mapz,screenymid-(mapy)*mapz , mapz*500,mapz*500 , mapxbar,screeny
	;DrawGrid2 mapxmid-mapx*mapz,screenymid-mapy*mapz , mapz*500,mapz*500 , mapxbar,screeny
	DrawGrid3 mapxmid-mapx*mapz,screenymid-mapy*mapz , mapz*500,mapz*500 , mapxbar,screeny , mapz,mapx*mapz-mapxmid,mapy*mapz-screenymid
	;DrawGrid2 -(mapx+250)*mapz,-(mapy+250)*mapz , mapz*500,mapz*500 , mapxbar,screeny , mapz
	
	Color 255,0,0
	Oval mapxmid,screenymid , 4,4
	
	mouseoverfm=Null
	For fm.formation=Each formation
		If RectsOverlap(mapxmid+(fm\x-mapx)*mapz,screenymid+(fm\y-mapy)*mapz,1,1,0,0,mapxbar,screeny) Then
			Select fm\freq
			Case pl\freq
				drawship mapxmid+(fm\x-mapx)*mapz,screenymid+(fm\y-mapy)*mapz,fm\angle,fm\roll,29-1*(fm=mapselfm)
				If fm\role=role_capship Then
					id$=Left(shipname(fm\freq,fm\designation),maxcallsign)
				Else
					id$=Left(designation(fm\freq,fm\designation),maxcallsign)
				EndIf
				sh.ship=pl\ship
				If fm=sh\formation Then id$=id$+"(You)"
				drawtext(id$,mapxmid+(fm\x-mapx)*mapz,screenymid+(fm\y-mapy)*mapz+font_y(0),0,font_yellow)
				Select fm\state
				Case state_attack
					fm2.formation=fm\target
					If fm2<>Null Then
					Color colour(currentcol,21,0),colour(currentcol,21,1),colour(currentcol,21,2)
					Line mapxmid+(fm\x-mapx)*mapz,screenymid+(fm\y-mapy)*mapz,mapxmid+(fm2\x-mapx)*mapz,screenymid+(fm2\y-mapy)*mapz
					EndIf
				End Select
			 Case fm\detected[pl\freq]=True
				drawship mapxmid+(fm\x-mapx)*mapz,screenymid+(fm\y-mapy)*mapz,fm\angle,0,34
				If fm\role=role_capship Then
					id$=Left(shipname(fm\freq,fm\designation),maxcallsign)
				Else
					id$=Left(designation(fm\freq,fm\designation),maxcallsign)
				EndIf
				drawtext(id$,mapxmid+(fm\x-mapx)*mapz,screenymid+(fm\y-mapy)*mapz+font_y(0),0,font_blue)
				Select fm\state
				Case state_attack
					fm2.formation=fm\target
					If fm2<>Null Then
					Color colour(currentcol,22,0),colour(currentcol,22,1),colour(currentcol,22,2)
					Line mapxmid+(fm\x-mapx)*mapz,screenymid+(fm\y-mapy)*mapz,mapxmid+(fm2\x-mapx)*mapz,screenymid+(fm2\y-mapy)*mapz
					EndIf
				End Select
			End Select
			If VectorDistance((mapxmid+(fm\x-mapx)*mapz)-MouseX(),(screenymid+(fm\y-mapy)*mapz)-MouseY())<=40*mapz
				mouseoverfm=fm
				If fm\freq=pl\freq And MouseHit(1) Then mapselfm=fm
			EndIf
		EndIf
	Next

    Color 0,192,64
    Text tbx,tby+0 , "Formations: "+Str$(hr(sh\freq)\formations[0])+" "+Str$(hr(sh\freq)\formations[1])+" "+Str$(hr(sh\freq)\formations[2])
    Text tbx,tby+15 , "Available: "+Str$(hr(sh\freq)\available[0])+" "+Str$(hr(sh\freq)\available[1])+" "+Str$(hr(sh\freq)\available[2])
    Text tbx,tby+30 , "Targets: "+Str$(hr(sh\freq)\targets[0])+" "+Str$(hr(sh\freq)\targets[1])+" "+Str$(hr(sh\freq)\targets[2])
    Text tbx,tby+45 , "Assignment: "+Str$(hr(sh\freq)\assignment[0])+" "+Str$(hr(sh\freq)\assignment[1])+" "+Str$(hr(sh\freq)\assignment[2])
	
	usFPS
	
	Viewport mapxbar,0,screenx-mapxbar,screeny
	ClsColor 0,0,0
	Cls

	;selected formation name
	If mapselfm\role=role_capship Then
		sh.ship=mapselfm\leader
		ss.ship_stats=sh\ship
		id$=shipname(mapselfm\freq,mapselfm\designation)
		fmdamage=Float sh\hp/ss\hp*100
	Else
		id$=designation(mapselfm\freq,mapselfm\designation)+" formation"
		counter=0
		For a=0 To maxformshp
			If mapselfm\ship[a]<>Null Then
				counter=counter+1
			EndIf
		Next
		fmdamage=Float counter/(maxformshp+1)*100
	EndIf
	drawtext(id$,mapxbar,font_y(1),1,font_green)
	;selected formation type
	drawtext("[Craft Type]",mapxbar,font_y(1)*2,1,font_green)
	;selected formation role
	drawtext(role(mapselfm\role,0),mapxbar,font_y(1)*3,1,font_green)
	;selected formation damage
	drawtext("Efficiency: "+fmdamage+"%",mapxbar,font_y(1)*4,1,font_green)

	drawtext("[State]",mapxbar,font_y(1)*6,1,font_green)
	
	loc$="X:"+Int mapselfm\x+" Y:"+Int mapselfm\y
	drawtext(loc$,mapxbar,font_y(1)*8,1,font_green)
	
	Color colour(currentcol,1,0),colour(currentcol,1,1),colour(currentcol,2,2)
	Rect mapxbar+2,1,1,screeny-2
	Color colour(currentcol,3,0),colour(currentcol,3,1),colour(currentcol,3,2)
	Rect mapxbar+1,2,1,screeny-4
	Rect mapxbar+3,2,1,screeny-4
	
	If mouseoverfm<>Null And mapselfm<>mouseoverfm Then
		If mouseoverfm\role=role_capship Then
			sh.ship=mouseoverfm\leader
			ss.ship_stats=sh\ship
			id$=shipname(mouseoverfm\freq,mouseoverfm\designation)
			fmdamage=Float sh\hp/ss\hp*100
		Else
			id$=designation(mouseoverfm\freq,mouseoverfm\designation)+" formation"
			counter=0
			For a=0 To maxformshp
				If mouseoverfm\ship[a]<>Null Then
					counter=counter+1
				EndIf
			Next
			fmdamage=Float counter/(maxformshp+1)*100
		EndIf
		drawtext(id$,mapxbar,screenymid+font_y(1),1,font_blue)
		;selected formation type
		drawtext("[Craft Type]",mapxbar,screenymid+font_y(1)*2,1,font_blue)
		;selected formation role
		drawtext(role(mouseoverfm\role,0),mapxbar,screenymid+font_y(1)*3,1,font_blue)
		;selected formation damage
		drawtext("Efficiency: "+fmdamage+"%",mapxbar,screenymid+font_y(1)*4,1,font_blue)

		drawtext("[State]",mapxbar,screenymid+font_y(1)*6,1,font_blue)

		Color colour(currentcol,1,0),colour(currentcol,1,1),colour(currentcol,2,2)
		Rect mapxbar+9,screenymid,screenx-mapxbar-14,1
	EndIf
	
	Flip VSync
    Delay 1  ; lowers cpu usage on multicore systems
	If CrawlLock
		Delay CrawlLockSpeed
	End If
Until KeyHit(1) Or KeyHit(57)  ; esc or space
ClsColor 0,0,0
Cls
FlushKeys
HidePointer
ResumeAllTimers
Goto main_battle_standard

;original code by Teasy
Function drawship( xpos,ypos , angle,rollpos , col )
;   Param xpos,ypos         ; pixel location on screen of ship center of rotation
;   Param angle             ; 0..360 degrees (0=up)
;   Param rollpos           ; -5 = full left, 0 = center, +5 = full right
;   Param col               ; ship color
    
    ; ship shape
    Local xT#,yT#,dT#,aT#   ; top
    Local xL#,yL#,dL#,aL#   ; left
    Local xR#,yR#,dR#,aR#   ; right
    Local xB#,yB#,dB#,aB#   ; bottom
    
    ; ship roll colors
    Local bL#,bR#   ; brightness left/right
    
    ; boundary checking
    rollpos = CapFloat( rollpos , -5,+5 )
    
    ; ship shape (grid coordinates)
    xT = 0
    yT = 0 - 10 + 2
    xL = 0 - 5
    yL = 0 + 3  + 2
    xR = 0 + 5
    yR = 0 + 3  + 2
    xB = 0
    yB = 0      + 2
    
    ; alter shape according to roll
    xL = xL - rollpos / 2
    xR = xR - rollpos / 2
    
    ; convert to distance/angle and rotate ship
    dT = vd( xT,yT )
    aT = va( xT,yT ) + angle
    dL = vd( xL,yL )
    aL = va( xL,yL ) + angle
    dR = vd( xR,yR )
    aR = va( xR,yR ) + angle
    dB = vd( xB,yB )
    aB = va( xB,yB ) + angle
    
    ; convert back to grid (x,y) and position ship
    xT = vx( dT,aT ) + xpos
    yT = vy( dT,aT ) + ypos
    xL = vx( dL,aL ) + xpos
    yL = vy( dL,aL ) + ypos
    xR = vx( dR,aR ) + xpos
    yR = vy( dR,aR ) + ypos
    xB = vx( dB,aB ) + xpos
    yB = vy( dB,aB ) + ypos
    
    ; colorize wings according to roll
    bL = ScalePoint( rollpos , -5,+5 , 0.5,1 )
    bR = ScalePoint( rollpos , -5,+5 , 1,0.5 )
    
    ; draw ship (center)
    Color colour(currentcol,col,0),colour(currentcol,col,1),colour(currentcol,col,2)
    Line xT,yT , xB,yB
    
    ; (left wing)
    Color colour(currentcol,col,0)*bL,colour(currentcol,col,1)*bL,colour(currentcol,col,2)*bL
    Line xT,yT , xL,yL
    Line xB,yB , xL,yL
    
    ; (right wing)
    Color colour(currentcol,col,0)*bR,colour(currentcol,col,1)*bR,colour(currentcol,col,2)*bR
    Line xT,yT , xR,yR
    Line xB,yB , xR,yR
    
End Function

Function drawtext(txt$,x,y,fnt,col)
	Local length=Len(txt)
	For a=1 To length
		DrawImage font(fnt),x+a*font_x(fnt),y,Asc(Mid(txt,a,1))+col
	Next
End Function

; splash the screen with a message
Function ScreenMessage( msg$ )
    SetBuffer BackBuffer()
    ;Local bd
    ;If backdrop(0) > 0
    ;    If backdrop(1) > 0
    ;        If backdrop(2) > 0
    ;            bd = True
    ;        End If
    ;    End If
    ;End If
    If backdroploaded
        Local x,y
        If pl <> Null
            x = pl\x
            y = pl\y
        Else
            x = Rand( -screenx,screenx )
            y = Rand( -screeny,screeny )
        End If
        TileBlock backdrop(0),-x/16,-y/32
        TileImage backdrop(1),7-x/8,-y/8
        TileImage backdrop(2),23-x/4,-y/4
    Else
        ClsColor 0,64,128
        Cls
    End If
	SetFont FontLarge
    TextOutLine screenx/2,screeny/2 , msg , True,True , 224,240,255 , 224*.75,240*.75,256*.75
    Flip
End Function

;-------------------------------------------------------------------------------
; * Replace ImagesCollide because of MAV bug
;-------------------------------------------------------------------------------
; If mask color is not black, you have to specify your color with the mask parameter 
; Due to ReadPixel commands this function will be slow, if large areas of the images overlap.
;-------------------------------------------------------------------------------
; 2010-01-08 Robert Hierl - www.mein-murks.de
; 2011-01-13 Teasy <TheChange@yahoo.com>
;-------------------------------------------------------------------------------
Function ImagesCollide(image1,xpos1,ypos1,frame1=0, image2,xpos2,ypos2,frame2=0, mask=0)
    
    If Not ImagesOverlap( image1,xpos1,ypos1 , image2,xpos2,ypos2 )
        Return
    End If
    
    Local width1  = ImageWidth(image1)
    Local height1 = ImageHeight(image1)
    Local width2  = ImageWidth(image2)
    Local height2 = ImageHeight(image2)
    
    xpos1   = xpos1 - ImageXHandle(image1)
    ypos1   = ypos1 - ImageYHandle(image1)
    xpos2   = xpos2 - ImageXHandle(image2)
    ypos2   = ypos2 - ImageYHandle(image2)
    
    Local startx = xpos2 - xpos1
    Local starty = ypos2 - ypos1
	Local offx = startx
	Local offy = starty
    
    Local endx   = startx + width2-1
    Local endy   = starty + height2-1
    
    If startx < 0       Then startx = 0
    If starty < 0       Then starty = 0
    If endx   >= width1  Then endx   = width1-1
    If endy   >= height1 Then endy   = height1-1
    
    ;endx = endx - 1
    ;endy = endy - 1
    
    If startx > endx Or starty > endy Then Return 0
    
    Local ix, iy
    
    Local ib1 = ImageBuffer(image1, frame1)
    LockBuffer ib1
    Local ib2 = ImageBuffer(image2, frame2)
    LockBuffer ib2
    For ix = startx To endx
        For iy = starty To endy
            
            If mask <> (ReadPixelFast(ix, iy, ib1) And $00FFFFFF) Then
                If mask <> (ReadPixelFast(ix-offx, iy-offy, ib2) And $00FFFFFF) Then
                    UnlockBuffer ib1
                    UnlockBuffer ib2
                    Return 1
                EndIf
            EndIf
        Next
    Next 
    UnlockBuffer ib1
    UnlockBuffer ib2
    
End Function 

;-------------------------------------------------------------------------------
Global x_,y_
Function Locate( x=0,y=0 )
	x_ = x
	y_ = y
	If x_ < 0 Then x_ = 0
	If x_ >= GraphicsWidth() Then x_ = GraphicsWidth() - StringWidth( " " ) - 1
	If y_ < 0 Then y_ = 0
	If y_ >= GraphicsHeight() Then y_ = GraphicsHeight() - FontHeight() - 1
End Function
Function Print( msg$="" , cr=True )
	SetBuffer FrontBuffer()
    ; check if x out of bounds
    If x_ >= GraphicsWidth()
        x_ = 0
        y_ = y_ + FontHeight()
    End If
    ; new line doesn't fit on screen
    If y_ >= GraphicsHeight() - FontHeight()
        Print_ScrollScreen
    End If
    If msg <> ""
        Text x_,y_ , msg
    End If
    ; carriage return (Print)
    If cr
        x_ = 0
        y_ = y_ + FontHeight()
    ; cursor behind text (Write)
    Else
        x_ = x_ + StringWidth( msg )
    End If
	;Flip False
End Function
Function Write( msg$ )
    Print msg , False
End Function
Function Print_ScrollScreen()
    Local gw = GraphicsWidth()
    Local gh = GraphicsHeight()
    Local fh = FontHeight()
    ; move all so far up that 1 line will fit
    CopyRect 0,y_-gh+fh+1 , gw,gh-fh , 0,0
    ; place cursor at last line
    y_ = gh-fh-1
    ; remember current color (minimal system independency)
    Local col_r = ColorRed()
    Local col_g = ColorGreen()
    Local col_b = ColorBlue()
	; assume lowerright pixel (screen) is background color (cheats! :)
	Local col = ReadPixel( gw-1,gh-1 )
    ; erase last line (with clscolor)
    Color 0,0,col
    Rect 0,y_ , gw,fh
    ; restore current color
    Color col_r,col_g,col_b
End Function
Function CursorX()
	Return x_
End Function
Function CursorY()
	Return y_
End Function
Function Print_Test1()
	SetBuffer FrontBuffer()
	Locate 0,screeny/2
	Local msg$
	Repeat
		msg = String( Chr(Rand(33,47)) , Rand(10,30) )
		Print CursorX()+","+CursorY()+" "+msg
		If CursorY() >= screeny*4./5
			Delay 1000
		Else
			Delay 500
		End If
	Until msg = " " Or KeyHit(1)
	End
End Function

;-------------------------------------------------------------------------------
; Like Text() only with 3x3 outline, for example to make white text visible on white background
Function TextOutLine( PosX%,PosY% , Message$ , CenterX=False,CenterY=False , InR=255,InG=255,InB=255 , OutR=0,OutG=0,OutB=0 , Separation=1 )
; 20 jan 2010:
; - added (x<>0 & y<>0) condition to favor cpu calc work over gpu draw work
; 09 sep 2007:
; - swapped inner/outer color (inner color is now white, outer is black)
    Local X%
    Local Y%
    
    Color OutR,OutG,OutB
    ; CenterX: 0 = Left justify, 1 = Center, 2 = Right justify
    If CenterX = 2
        PosX = PosX - StringWidth( Message )
        CenterX = False
    EndIf
    ; CenterY: 0 = Top justify, 1 = Center, 2 = Bottom justify
    If CenterY = 2
        PosY = PosY - StringHeight( Message )
        CenterY = False
    EndIf
    For X = -1 To 1
        For Y = -1 To 1
            If X <> 0 And Y <> 0
                Text PosX + X * Separation , PosY + Y * Separation , Message , CenterX , CenterY
            End If
        Next
    Next
    Color InR,InG,InB
    Text PosX,PosY , Message , CenterX,CenterY
    
End Function

;-------------------------------------------------------------------------------
; update and show fps
Global lastfps,frames,fps
Function usFPS()
	If MilliSecs-lastfps>=1000
		lastfps=MilliSecs
		fps=frames
		frames=0
	End If
	frames=frames+1
	Color 64,128,192
	Text screenx/2,screeny-FontHeight()-1 , fps+" FPS" , True
End Function

;~IDEal Editor Parameters:
;~B#2B8#2E5#48C#4AB#92B#A8B#CCA
;~C#Blitz3D1105